/*
FileName:AddEpic.js
Version:1.0.0
Purpose:Adding Epic to Backlogs
Devloper:Mahesh
*/
import React, { Component } from 'react';
import Requesteddata from '../AdminComponets/AdminRequestedDataProjects';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert } from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import Icon from 'react-native-vector-icons/FontAwesome';

import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import Toast from 'react-native-whc-toast';
import log from '../LogFile/Log';
import SearchableDropdown from 'react-native-searchable-dropdown';
import TimePicker from "react-native-super-timepicker";
import ModalSelector from 'react-native-modal-selector';

export default class SettingsModify extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            open: false,
            modulename: '',
            epicName: 'Select Epic',
            ts_id: this.props.navigation.state.params.ts_id,
            time: this.props.navigation.state.params.start_time,

            modalVisible: false,

            time1: this.props.navigation.state.params.end_time,//idea id
            textInputValue: this.props.navigation.state.params.time_zone,//moduledesc

            error: '',
            resource: [],

            itemPressedDisabled: false,
        };

    }
    //Open the Dialog Modal
    modalDidOpen = () => console.log("Modal did open.");
    //close the Dialog Modal
    modalDidClose = () => {
        this.props.navigation.goBack();
        this.setState({ open: false }); this.setState({ open: false });
        console.log("Modal did close.");

    };

    //Dialog actions start
    moveUp = () => this.setState({ offset: -100 });

    resetPosition = () => {
        this.setState({ offset: 0 });
        this.props.navigation.goBack();
    }

    //open the dialog 
    openModal = () => {
        this.setState({ open: true })

    };
    //close the dialog
    closeModal = () => {
        this.setState({ open: false });
        this.props.navigation.goBack();
    }
    //Dialog actions end
    componentDidMount() {
        log("Debug", "Module Add screen is loaded");
        this.openModal();
        this.getEpic();

        // this.setModalVisible(!this.state.modalVisible);
    }

    //Refresh data
    onRefresh() {
        this.setState({ isFetching: true }, function () { this.add() });
    }

    //getting the Employees list for addind maintask
    getEpic() {
        log("Info", " getEpic(cropcode) is used for getting the Epics list for adding Epic to userstory");
        // const { ModuleId } = this.state;
        // const { ideaid } = this.state;

        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;

            AsyncStorage.getItem("emp_role", (err, res) => {
                const emp_role = res;
                AsyncStorage.getItem("userToken", (err, res) => {
                    const userToken = res;
                    AsyncStorage.getItem("projectId", (err, res) => {
                        const projectId = res;

                        NetInfo.fetch().then(state => {
                            if (state.type == "none") {
                                console.log(state.type);
                                log("Warn", "No internet connection");
                                Snackbar.show({
                                    title: 'No Internet Connection',
                                    backgroundColor: 'red',
                                    duration: Snackbar.LENGTH_LONG,
                                });
                            } else {
                                fetch(API + 'get_epics.php',
                                    {
                                        method: 'POST',
                                        headers: {
                                            Accept: 'application/json',
                                            'Content-Type': 'application/json',
                                        },
                                        body: JSON.stringify({
                                            corp: cropcode,
                                            action: "get_epics",
                                            userType: emp_role,
                                            empId: userToken,
                                            projectId: projectId,


                                        })
                                    })
                                    .then((response) => response.json())
                                    .then((responseJson) => {
                                        if (responseJson.status === 'True') {

                                            var epicsList = [];
                                            responseJson.data.map((epics) => {
                                                return (
                                                    epicsList.push({
                                                        'id': epics.idea_id, 'name': epics.idea_title
                                                    })
                                                );
                                            })

                                            this.setState({
                                                resource: epicsList
                                            });
                                        }
                                    })
                                    .catch((error) => {
                                        console.error(error);
                                        log("Error", "requested projects error");
                                    });
                            }
                        });
                    });
                });
            });
        });
    }

    //Validatios
    isValid() {
        const { epicId } = this.state;
        let valid = false;

        if (epicId.length === 0) {
            log("Warn", "Epic should not be empty");
            this.setState({ error1: 'Select Epic' });
        }


        else {
            valid = true;
        }
        return valid;
    }

    onCancel() {
        this.TimePicker1.close();
        this.TimePicker2.close();
    }

    onConfirm(hour, minute) {

        this.setState({ time: `${hour}:${minute}` });
        this.TimePicker1.close();
        // alert(`${hour}:${minute}`)
    }
    onConfirm1(hour1, minute1) {

        this.setState({ time1: `${hour1}:${minute1}` });
        this.TimePicker2.close();
        // alert("end time"+`${hour1}:${minute1}`)

    }


    //Add time shift 
    addTimeShift() {
        log("Info", " addTimeShift(cropcode) is used for getting the Employees list for addind maintask");
        const { hour, minute, hour1, minute1, textInputValue, ts_id } = this.state;
        // alert(ts_id)
        // const start_time=hour+minute;
        const { time } = `${hour}:${minute}`;
        const { time1 } = `${hour1}:${minute1}`;
        // alert(this.state.time);
        // alert(textInputValue)
        // alert("Time1"+this.state.time1);
        // const { ideaid } = this.state;
        // alert("test")
        // AsyncStorage.getItem("time", (err, res) => {
        //   const time = res;
        //   alert("Start Time"+this.state.time)
        //   AsyncStorage.getItem("time1", (err, res) => {
        //     const time1 = res;
        NetInfo.fetch().then(state => {
            if (state.type == "none") {
                console.log(state.type);
                log("Warn", "No internet connection");
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.getOfflineSprints(); //Getting Offline Sprint List
            } else {
                fetch(API + 'get_user_shifts.php',
                    {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            // crop: cropcode,
                            action: 'modify_shift',
                            // projectId: projectId,
                            start_time: this.state.time,
                            end_time: this.state.time1,
                            time_zone: textInputValue,
                            ts_id: ts_id,
                        })
                    })

                    .then((response) => response.json())

                    .then((responseJson) => {

                        if (responseJson.status === 'True') {
                            // this.getShifts();
                            alert(JSON.stringify(responseJson.message))
                            // console.warn("Sprints from active sprint board" + JSON.stringify(responseJson))
                            // alert(JSON.stringify(responseJson))
                            var sprintDetails = [];

                            responseJson.data.map((sprints) => {
                                const [year, month, date] = sprints.startDate.split('-');
                                const [year1, month1, date1] = sprints.targetDate.split('-');
                                return (
                                    sprintDetails.push({ 'key': sprints.moduleId, 'epicId': sprints.ideaId, 'label': sprints.moduleDesc })
                                );
                            })

                            this.setState({
                                resource: sprintDetails
                            });
                            this.addOfflineSprints(sprintDetails, cropcode)//Store Sprint List in Offline
                        }
                    })
                    .catch((error) => {
                        // alert("test")
                        console.error(error);
                        log("Error", "requested projects error");
                    });
            }
        });
        //   });
        // });
        this.closeModal();
    }

    render() {
        let index = 0;
        const data = [
            { key: index++, label: 'IST' },
            { key: index++, label: 'EST' },
            { key: index++, label: 'CST' },
            { key: index++, label: 'PST' },
            { key: index++, label: 'GMT' },
            { key: index++, label: 'MST' },
            { key: index++, label: 'ARAB' },
        ];



        return (
            <Modal
                offset={this.state.offset}
                closeOnTouchOutside={false}
                open={this.state.open}
                modalDidOpen={this.modalDidOpen}
                modalDidClose={this.modalDidClose}
                style={{ alignItems: "center" }} >



                <View >
                    <View style={{flexDirection:'row'}}>
                    <TouchableOpacity
                        onPress={() => this.TimePicker1.open()}
                        style={{ width: '45%', backgroundColor: 'transparent', borderWidth: 1, borderColor: 'black', margin: 10, height: 40 }}
                    >
                        <Text style={{ padding: 10 }}>Start Time : {this.state.time}</Text>
                    </TouchableOpacity>



                    {/* Time 1 */}
                    <TimePicker
                        ref={(ref) => {
                            this.TimePicker1 = ref;
                        }}
                        onCancel={() => this.onCancel()}
                        onConfirm={(hour, minute) => this.onConfirm(hour, minute)}
                    // onValueChange={this._onValueChange1}

                    />

                    {/* <Text style={styles.text}>start date : {this.state.time}</Text> */}
                    <TouchableOpacity
                        onPress={() => this.TimePicker2.open()}
                        style={{ width: '45%', backgroundColor: 'transparent', borderWidth: 1, borderColor: 'black', margin: 10, height: 40 }}
                    >
                        <Text style={{ padding: 10 }}>End Time : {this.state.time1}</Text>
                    </TouchableOpacity>


                    {/* Time 2 */}
                    <TimePicker
                        ref={(ref) => {
                            this.TimePicker2 = ref;
                        }}
                        onCancel={() => this.onCancel()}
                        onConfirm={(hour1, minute1) => this.onConfirm1(hour1, minute1)}
                    // onValueChange={this._onValueChange2}

                    />

                    {/* <Text style={styles.text}>end Date : {this.state.time1}</Text> */}
                    </View>
                </View>

                <View style={{ flexDirection: 'row' }}>
                    <ModalSelector
                        style={{ width: '95%', backgroundColor: 'transparent', borderWidth: 1, borderColor: 'black', margin: 10 }}
                        data={data}
                        initValue="Select something yummy!"
                        supportedOrientations={['landscape']}
                        accessible={true}
                        scrollViewAccessibilityLabel={'Scrollable options'}
                        cancelButtonAccessibilityLabel={'Cancel Button'}
                        onChange={(option) => { this.setState({ textInputValue: option.label }) }}>
                        <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>
                            {/* <Text style={{ marginTop: 15, color: 'black', width: 80 }}>PROJECT : </Text> */}

                            <Text style={{ marginTop: 12, color: 'black', width: 120, marginLeft: 10 }}>{this.state.textInputValue}</Text>

                            <Icon name="md-chevron-down-outline" size={25} style={{ color: 'white', marginTop: 10, }}
                            />
                        </View>


                        {/* <TextInput
                        style={{borderWidth:1, borderColor:'#ccc', padding:10, height:30}}
                        editable={false}
                        placeholder="Select something yummy!"
                        value={this.state.textInputValue} /> */}

                    </ModalSelector>
                </View>

                <View style={{ flexDirection: 'row', marginTop: 20, alignItems: 'center', justifyContent: 'center', alignSelf: 'center', }}>
                    <TouchableOpacity style={styles.opensave} onPress={this.addTimeShift.bind(this)} disabled={this.state.itemPressedDisabled}>
                        <Text style={{ color: 'white' }}>SAVE</Text>
                    </TouchableOpacity>
                    <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                        <Text style={{ color: 'white' }}>CANCEL</Text>
                    </TouchableOpacity>
                </View>
            </Modal>


        );

    }

}
//Styles for UI
const styles = StyleSheet.create(
    {
        MainContainer:
        {
            flex: 1,
            width: Dimensions.get('window').width,
            height: Dimensions.get('window').height
        },
        bottomView: {
            flexDirection: 'row',
            justifyContent: 'center',
            position: 'absolute',
            // height: FOOTER_MAX_HEIGHT,
            bottom: 0,
            left: 0,
            right: 0,
            backgroundColor: 'black',
            alignItems: 'center'
        },

        textStyle: {
            color: '#fff',
            fontSize: 18
        },
        container: {
            flex: 1,
            width: '90%',
            paddingLeft: hp('2%'),
        },
        footer: {
            position: 'absolute',
            flex: 0.1,
            left: 0,
            right: 0,
            bottom: -10,
            backgroundColor: 'green',
            flexDirection: 'row',
            height: 80,
            alignItems: 'center',
        },
        bottomButtons: {
            alignItems: 'center',
            justifyContent: 'center',
            flex: 1,
        },
        footerText: {
            color: 'white',
            fontWeight: 'bold',
            alignItems: 'center',
            fontSize: 18,
        },
        buttonContainer: {
            width: wp('90%'),
            alignSelf: 'baseline',
            marginBottom: 25,
            color: '#d2691e',
            marginLeft: 4,



        },
        signupButton: {

            backgroundColor: '#ffffff',
        },
        subcontainer: {
            flex: 2,
            flexDirection: 'row',
            paddingTop: 40
        },
        signUpText0: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

        },
        signUpText1: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            paddingLeft: 10,
        },
        end: {

            alignItems: 'flex-end',

        },
        end1: {
            flex: 2,
            height: '50%',
            paddingTop: 20,
            justifyContent: 'space-between',

            flexDirection: 'row',
        },
        s: {
            justifyContent: 'center',

            backgroundColor: '#ed7070',
            shadowOffset: { width: 50, height: 50 },
            alignItems: 'center',
            width: wp('40%'),
            height: hp('12%'),

        },
        signUpText2: {
            fontSize: 10,
            marginLeft: 200,
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            //  marginRight: 10,
            //textAlign: "right"

        },
        signUpText3: {

            fontSize: 12,
            paddingTop: 10,
            paddingLeft: 10,

            alignItems: 'center',
        },
        signUpText4: {
            fontSize: 12,
            paddingTop: 10,


            alignItems: 'center',
        },
        signup: {
            //paddingTop:20,
            color: "#FFF",

        },
        boxone: {
            flex: 1,
            marginTop: 5,

        },
        boxtwo: {
            flex: 1,

        },
        boxthree: {
            flex: 1,

        },
        box: {
            flexDirection: 'row',
            position: 'relative',
            marginBottom: 10,


        },
        signUpText: {
            fontSize: 20,
            justifyContent: 'center',


            color: 'white',
            alignSelf: 'center',
        },
        opencancel: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
        opensave: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
    });