/*
FileName:AddStory.js
Version:1.0.0
Purpose: Add or Modify the Maintask 
Devloper:Mahesh Reddy
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, Text, View, StatusBar, Dimensions, Picker, TouchableOpacity, Linking, TextInput, Alert } from 'react-native';
import { Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Icon from 'react-native-vector-icons/MaterialCommunityIcons';
import SearchableDropdown from 'react-native-searchable-dropdown';
import AsyncStorage from '@react-native-community/async-storage';
// import { tsMethodSignature } from '@babel/types';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import ModalSelector from 'react-native-modal-selector';
// import { Dropdown } from 'react-native-material-dropdown';
import log from '../LogFile/Log';
import Toast from 'react-native-whc-toast';
import { MAINTASKINFO, MAINTASKTITLE, DESCRIPTION, } from '../CommonComponents/Header';
import { ScrollView } from 'react-native-gesture-handler';

export default class AddStory extends Component {

  constructor(props) {
    super(props);

    this.state = {
      assignedName: 'Select Squad Name *',
      epicName: 'Select Epic Name',
      tasktitle: '',
      taskdescription: '',
      modalVisible: false,
      resource: [],
      epics: [],
      epicId: '',
      // name: "",
      assignedto: '',
      acceptanceCriteria: '',
      storyPoints: '',
      priorityLevel: '',
      user: '',
      ModuleId: this.props.navigation.state.params.moduleid,//ModuleId
      ideaid: this.props.navigation.state.params.IdeaId,//Idea Id
      addTask: this.props.navigation.state.params.addTask,//action for add task
      modifyTask: this.props.navigation.state.params.modifyTask,//action for modify task
      maintaskid: this.props.navigation.state.params.maintaskid,//maintaskId
      error1: '', error2: '', error: '',
      maintasktitle: this.props.navigation.state.params.maintasktitle,//maintaskId,
      maintaskdesc: this.props.navigation.state.params.maintaskdesc,//maintaskId
      sprintDesc: this.props.navigation.state.params.sprintDesc,
      itemPressedDisabled: false,
    };
  }

  //getting the Employees list for addind maintask
  getEmployees() {
    log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
    const { ModuleId } = this.state;
    const { ideaid } = this.state;
    // console.warn("ModuleId"+ModuleId)
    AsyncStorage.getItem("projectId", (err, res) => {
      const projectId = res;

      AsyncStorage.getItem("cropcode", (err, res) => {
        const cropcode = res;
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'agile_squads.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  crop: cropcode,
                  projectId: projectId,

                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                console.warn(JSON.stringify(responseJson))
                if (responseJson.status === 'True') {

                  var empList = [];
                  responseJson.data.map((employee) => {
                    return (
                      empList.push({
                        'id': employee.id, 'name': employee.name
                      })
                    );
                  })

                  this.setState({
                    resource: empList,
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "requested projects error");
              });
          }
        });
      });
    });
  }


  //getting the Employees list for addind maintask
  getEpic() {
    log("Info", " getEpic(cropcode) is used for getting the Epics list for adding Epic to userstory");
    // const { ModuleId } = this.state;
    // const { ideaid } = this.state;

    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;

      AsyncStorage.getItem("emp_role", (err, res) => {
        const emp_role = res;
        AsyncStorage.getItem("userToken", (err, res) => {
          const userToken = res;
          AsyncStorage.getItem("projectId", (err, res) => {
            const projectId = res;

            NetInfo.fetch().then(state => {
              if (state.type == "none") {
                console.log(state.type);
                log("Warn", "No internet connection");
                Snackbar.show({
                  title: 'No Internet Connection',
                  backgroundColor: 'red',
                  duration: Snackbar.LENGTH_LONG,
                });
              } else {
                fetch(API + 'get_epics.php',
                  {
                    method: 'POST',
                    headers: {
                      Accept: 'application/json',
                      'Content-Type': 'application/json',
                    },
                    body: JSON.stringify({
                      corp: cropcode,
                      action: "get_epics",
                      userType: emp_role,
                      empId: userToken,
                      projectId: projectId,

                    })
                  })
                  .then((response) => response.json())

                  .then((responseJson) => {
                    // alert(JSON.stringify(responseJson))
                    if (responseJson.status === 'True') {

                      var epicsList = [];
                      responseJson.data.map((epics) => {
                        return (
                          epicsList.push({
                            'id': epics.id, 'name': epics.idea_title
                          })
                        );
                      })

                      this.setState({
                        epics: epicsList
                      });
                    }
                  })
                  .catch((error) => {
                    console.error(error);
                    log("Error", "requested projects error");
                  });
              }
            });
          });
        });
      });
    });
  }

  //Checking the Validations
  isValid() {
    const { tasktitle, taskdescription,acceptanceCriteria, assignedto } = this.state;
    let valid = false;
    console.warn(this.state.assignedto);
    if (tasktitle.length === 0) {
      log("Warn", "tasktitle title should not be empty");
      this.setState({ error1: 'Enter Title ' });
    }
    else if (taskdescription.length === 0) {
      // alert("Enter Description");
      log("Warn", "taskdescription title should not be empty");
      this.setState({ error2: 'Enter Description ' });
    }
    else if (acceptanceCriteria.length === 0) {
      log("Warn", "acceptanceCriteria should not be empty");
      this.setState({ error4: 'Enter Acceptance Criteria' });
    }
    else if (assignedto.length === 0) {
      log("Warn", "taskdescription title should not be empty");
      this.setState({ error3: 'Select Source ' });
    }

    else {
      valid = true;
    }
    return valid;
  }

    //Checking the Validations
    isValid2() {
      const { tasktitle, taskdescription, acceptanceCriteria } = this.state;
      let valid = false;
      console.warn(this.state.assignedto);
      if (tasktitle.length === 0) {
        log("Warn", "tasktitle title should not be empty");
        this.setState({ error1: 'Enter Title ' });
      }
      else if (taskdescription.length === 0) {
        // alert("Enter Description");
        log("Warn", "taskdescription title should not be empty");
        this.setState({ error2: 'Enter Description ' });
      }
      else if (acceptanceCriteria.length === 0) {
        log("Warn", "acceptanceCriteria should not be empty");
        this.setState({ error4: 'Enter Acceptance Criteria' });
      }
  
      else {
        valid = true;
      }
      return valid;
    }
  

  //to add the new project from user 
  addMainTask = () => {
    log("Info", "addProject() method is used to add new project at user side");
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == "unknown" || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
      }
      else {
        const { tasktitle, taskdescription, acceptanceCriteria, storyPoints, ideaid, ModuleId, priorityLevel, epicId } = this.state;
        const { assignedto } = this.state;
        console.warn("tasktitle" + tasktitle);
        console.warn("taskdescription" + taskdescription);
        console.warn("assignedto" + assignedto);
        console.warn("acceptanceCriteria" + acceptanceCriteria);
        console.warn("epicId" + epicId);
        console.warn("storyPoints" + storyPoints);
        console.warn("priorityLevel" + priorityLevel);

        if (this.isValid()) {
          this.setState({ itemPressedDisabled: true })
          AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            AsyncStorage.getItem("projectId", (err, res) => {
              const projectId = res;
              console.warn("userToken" + userToken)
              const role = response[2][1];
              AsyncStorage.getItem("userId", (err, res) => {
                const userId = res;
                fetch(API + 'manage_userstories.php', {
                  method: 'POST',
                  headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                  },
                  body: JSON.stringify({
                    // proj_title: this.state.ProjectTitle,
                    // proj_desc: this.state.ProjectDescription,
                    // empId:userToken, //Async
                    // action: "add",
                    // crop: cropcode //Async

                    action: "add",
                    crop: cropcode,
                    title: this.state.tasktitle,
                    description: this.state.taskdescription,
                    // module_id: ModuleId,
                    module_id: '',
                    idea_id: epicId,
                    added_to: this.state.assignedto,
                    acceptanceCriteria: acceptanceCriteria,
                    storyPoints: storyPoints,
                    added_by: userToken,
                    priorityLevel: this.state.priorityLevel,
                    sprintDesc: this.state.sprintDesc,
                    epicId: this.state.epicId,
                    projectId: projectId,
                    device_id: userId,
                  })
                }).then((response) => response.json())
                  .then((responseJson) => {
                    console.warn("Data Testing" + JSON.stringify(responseJson));
                    console.log(responseJson);


                    if (responseJson.status === 'True') {

                      this.refs.toast.showCenter('User Story Added Successfully');
                      this.props.navigation.goBack();
                      console.log(responseJson);
                      alert("User Story Added Successfully");
                      this.setState({ itemPressedDisabled: false })
                      console.log("done")



                    }
                  }).catch((error) => {
                    console.error(error);
                    log("Error", "error in User Story adding");
                  });
              });
            });
          });
          // this.closeModal();
        }
      }

    });

  };

  //to add the new project from user 
  addSaveTemplete = () => {
    log("Info", "addProject() method is used to add new project at user side");
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == "unknown" || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
      }
      else {
        const { tasktitle, taskdescription, acceptanceCriteria, storyPoints, ideaid, ModuleId, priorityLevel, epicId } = this.state;
        const { assignedto } = this.state;
        console.warn("tasktitle" + tasktitle);
        console.warn("taskdescription" + taskdescription);
        console.warn("assignedto" + assignedto);
        console.warn("acceptanceCriteria" + acceptanceCriteria);
        console.warn("epicId" + epicId);
        console.warn("storyPoints" + storyPoints);
        console.warn("priorityLevel" + priorityLevel);

        if (this.isValid()) {
          this.setState({ itemPressedDisabled: true })
          AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            AsyncStorage.getItem("projectId", (err, res) => {
              const projectId = res;
              console.warn("userToken" + userToken)
              const role = response[2][1];
              AsyncStorage.getItem("userId", (err, res) => {
                const userId = res;
                fetch(API + 'manage_template.php', {
                  method: 'POST',
                  headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                  },
                  body: JSON.stringify({
                    // proj_title: this.state.ProjectTitle,
                    // proj_desc: this.state.ProjectDescription,
                    // empId:userToken, //Async
                    // action: "add",
                    // crop: cropcode //Async

                    action: "add",
                    crop: cropcode,
                    title: this.state.tasktitle,
                    description: this.state.taskdescription,
                    // module_id: ModuleId,
                    module_id: '',
                    idea_id: epicId,
                    added_to: this.state.assignedto,
                    acceptanceCriteria: acceptanceCriteria,
                    storyPoints: storyPoints,
                    added_by: userToken,
                    priorityLevel: this.state.priorityLevel,
                    sprintDesc: this.state.sprintDesc,
                    epicId: this.state.epicId,
                    projectId: projectId,
                    device_id: userId,
                  })
                }).then((response) => response.json())
                  .then((responseJson) => {
                    console.warn("Data Testing" + JSON.stringify(responseJson));
                    console.log(responseJson);


                    if (responseJson.status === 'True') {

                      this.refs.toast.showCenter('User Story Added Successfully');
                      this.props.navigation.goBack();
                      console.log(responseJson);
                      alert("User Story Added Successfully");
                      this.setState({ itemPressedDisabled: false })
                      console.log("done")



                    }
                  }).catch((error) => {
                    console.error(error);
                    log("Error", "error in User Story adding");
                  });
              });
            });
          });
          // this.closeModal();
        }
      }

    });

  };




  //to add the new project from user 
  saveTemplete = () => {
    log("Info", "addProject() method is used to add new project at user side");
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == "unknown" || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
      }
      else {
        const { tasktitle, taskdescription, acceptanceCriteria, storyPoints, ideaid, ModuleId, priorityLevel, epicId } = this.state;
        const { assignedto } = this.state;
        console.warn("tasktitle" + tasktitle);
        console.warn("taskdescription" + taskdescription);
        console.warn("assignedto" + assignedto);
        console.warn("acceptanceCriteria" + acceptanceCriteria);
        console.warn("epicId" + epicId);
        console.warn("storyPoints" + storyPoints);
        console.warn("priorityLevel" + priorityLevel);

        if (this.isValid2()) {
          this.setState({ itemPressedDisabled: true })
          AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            AsyncStorage.getItem("projectId", (err, res) => {
              const projectId = res;
              console.warn("userToken" + userToken)
              const role = response[2][1];
              AsyncStorage.getItem("userId", (err, res) => {
                const userId = res;
                fetch(API + 'manage_template.php', {
                  method: 'POST',
                  headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json',
                  },
                  body: JSON.stringify({
                    // proj_title: this.state.ProjectTitle,
                    // proj_desc: this.state.ProjectDescription,
                    // empId:userToken, //Async
                    // action: "add",
                    // crop: cropcode //Async

                    action: "templateOnly",
                    crop: cropcode,
                    title: this.state.tasktitle,
                    description: this.state.taskdescription,
                    // module_id: ModuleId,
                    module_id: '',
                    idea_id: epicId,
                    added_to: this.state.assignedto,
                    acceptanceCriteria: acceptanceCriteria,
                    storyPoints: storyPoints,
                    added_by: userToken,
                    priorityLevel: this.state.priorityLevel,
                    sprintDesc: this.state.sprintDesc,
                    epicId: this.state.epicId,
                    projectId: projectId,
                    device_id: userId,
                  })
                }).then((response) => response.json())
                  .then((responseJson) => {
                    console.warn("Data Testing" + JSON.stringify(responseJson));
                    console.log(responseJson);
                    //alert(responseJson)

                    if (responseJson.status === 'True') {

                      this.refs.toast.showCenter('User Story Added Successfully');
                      this.props.navigation.goBack();
                      console.log(responseJson);
                      alert("User Story Added Successfully");
                      this.setState({ itemPressedDisabled: false })
                      console.log("done")



                    }
                  }).catch((error) => {
                    console.error(error);
                    log("Error", "error in User Story adding");
                  });
              });
            });
          });
          // this.closeModal();
        }
      }

    });

  };



  //   //Add or Modify the Maintask start
  //   addMainTask() {

  //     log("Info", " addMainTask(addTask, modifyTask,) is used to add maintask");
  //     const { addTask } = this.state;
  //     const { modifyTask } = this.state;

  //     const { ModuleId } = this.state;
  //     const { ideaid } = this.state;
  //     const { acceptanceCriteria}=this.state;
  //     const {storyPoints}=this.state;
  //    console.warn("storyPoints"+storyPoints);

  // else if (addTask == 'add') { //Add subtask

  //       const { ModuleId } = this.state;
  //       const { ideaid } = this.state;
  //       AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
  //         const cropcode = response[0][1];
  //         const userToken = response[1][1];
  //         NetInfo.fetch().then(state => {
  //           if (state.type == "none") {
  //             console.log(state.type);
  //             Snackbar.show({
  //               title: 'No Internet Connection',
  //               backgroundColor: 'red',
  //               duration: Snackbar.LENGTH_LONG,
  //             });
  //           } else {
  //             if (this.isValid()) {
  //               fetch(API + 'manageMaintasks.php',
  //                 {
  //                   method: 'POST',
  //                   headers: {
  //                     Accept: 'application/json',
  //                     'Content-Type': 'application/json',
  //                   },
  //                   body: JSON.stringify({
  //                     action: "add",
  //                     crop: cropcode,
  //                     title: this.state.tasktitle,
  //                     description: this.state.taskdescription,
  //                     module_id: ModuleId,
  //                     idea_id: ideaid,
  //                     added_to: this.state.assignedto,
  //                     acceptanceCriteria:acceptanceCriteria,
  //                     storyPoints:storyPoints,
  //                     added_by: userToken,
  //                   })
  //                 })
  //                 .then((response) => response.json())
  //                 .then((responseJson) => {
  //                   this.refs.toast.showCenter('User Story Added');
  //                   this.props.navigation.goBack();
  //                   console.log(responseJson);
  //                 })
  //                 .catch((error) => {
  //                   console.error(error);
  //                 });
  //             }
  //           }

  //         });

  //       });

  //     } else {

  //       Alert.alert("No Action");
  //     }
  //   }
  //Add or Mpdify the Maintask close
  componentDidMount() {
    //Getting Employees List
    log("Debug", "Add Task screen is loaded");
    this.getEmployees();
    this.getEpic();
  }

  render() {


    let index = 0;
    const data = [
      { key: index++, label: '1' },
      { key: index++, label: '2' },
      { key: index++, label: '3' },
      { key: index++, label: '5' },
      { key: index++, label: '8' },
      { key: index++, label: '13', },

    ];

    const data1 = [
      { key: index++, label: '1' },
      { key: index++, label: '2' },
      { key: index++, label: '3' },
      { key: index++, label: '4' },
      { key: index++, label: '5' },


    ];
    // console.warn("assigned to in render"+this.state.assignedto);

    return (
      <Container>
        <Header
          androidStatusBarColor="#00A2C1"

          style={{
            backgroundColor: '#00A2C1',
            height: 60,
            width: Dimensions.get('window').width,
            borderBottomColor: '#ffffff',
            justifyContent: 'space-between',
          }}>
          <Left>
            <Icon name="arrow-left" size={25} style={{ color: '#fff', }} onPress={() =>
              this.props.navigation.goBack(null)} />
          </Left>
          <Body>
            <Title style={{ color: '#fff', fontWeight: '600' }}>{MAINTASKINFO}</Title>
          </Body>
          <Right></Right>
        </Header>

        <Content>
          <Toast ref="toast" />
          <View style={{ paddingTop: 20, }}>
            <View style={{ paddingLeft: 10, }}>

              <TextInput style={{ width: wp('95%'), height: 45, color: 'black', borderBottomWidth: 1, }}
                placeholder="User Story Title *"
                underlineColorAndroid='transparent'
                // selectionColor='white'
                onChangeText={(maintask) => this.setState({ tasktitle: maintask })}
              >
              </TextInput>

              <Text style={{ color: 'red' }}>{this.state.error1}</Text>
            </View>

            <View style={{ paddingLeft: 10, }}>


              <TextInput style={{ width: wp('95%'), height: 45, color: 'black', borderBottomWidth: 1, }}
                placeholder='Description: *'
                underlineColorAndroid='transparent'
                // selectionColor='white'
                onChangeText={(description) => this.setState({ taskdescription: description })}>
              </TextInput>
              <Text style={{ color: 'red' }}>{this.state.error2}</Text>
            </View>

            <View style={{ paddingLeft: 10, }}>


              <TextInput style={{ width: wp('95%'), height: 45, color: 'black', borderBottomWidth: 1, }}
                placeholder="Acceptance Criteria/Definition of Done *"
                underlineColorAndroid='transparent'
                // selectionColor='white'
                onChangeText={(acceptanceCriteria) => this.setState({ acceptanceCriteria: acceptanceCriteria })}>
              </TextInput>
              <Text style={{ color: 'red' }}>{this.state.error4}</Text>
            </View>


            <View style={{ paddingTop: 10, }}>

              <SearchableDropdown
                placeholder={this.state.assignedName}
                onTextChange={text => console.log(text)}
                // value={this.state.assignedName}
                // onItemSelect={item => item.name}
                onItemSelect={(item) => this.setState({ assignedto: item.id, assignedName: item.name })}
                placeholderTextColor='black'
                containerStyle={{ padding: 5 }}
                textInputStyle={{
                  padding: 12,
                  borderWidth: 1,
                  borderColor: '#ccc',
                  // backgroundColor: '#FAF7F6',
                }}
                itemStyle={{
                  padding: 10,
                  marginTop: 2,
                  backgroundColor: '#FAF9F8',
                  borderColor: '#bbb',
                  borderWidth: 1,
                }}
                itemTextStyle={{

                  color: '#222',
                }}
                itemsContainerStyle={{

                  // maxHeight: '60%',
                }}
                items={this.state.resource}

                defaultIndex={2}

                // placeholder=""

                resetValue={false}

                underlineColorAndroid="transparent"

              />
              <Text style={{ color: 'red' }}>{this.state.error3}</Text>
            </View>

            <View style={{ paddingTop: 10, }}>
              <SearchableDropdown
                placeholder={this.state.epicName}
                onTextChange={text => console.log(text)}
                value={this.state.epicId}
                placeholderTextColor='black'
                // onItemSelect={item => item.name}
                onItemSelect={(item) => this.setState({ epicId: item.id, epicName: item.name })}
                containerStyle={{ padding: 5 }}
                textInputStyle={{
                  padding: 12,
                  borderWidth: 1,
                  borderColor: '#ccc',
                  // backgroundColor: '#FAF7F6',
                }}
                itemStyle={{
                  padding: 10,
                  marginTop: 2,
                  backgroundColor: '#FAF9F8',
                  borderColor: '#bbb',
                  borderWidth: 1,
                }}
                itemTextStyle={{

                  color: '#222',
                }}
                itemsContainerStyle={{

                  // maxHeight: '60%',
                }}
                items={this.state.epics}

                defaultIndex={2}

                // placeholder=""

                resetValue={false}

                underlineColorAndroid="transparent"

              />
              {/* <Text style={{ color: 'red' }}>{this.state.error}</Text> */}
            </View>
            <Text style={{ marginLeft: 10, paddingTop: 10 }}>Story Points</Text>


            <ModalSelector
              data={data}
              initValue="Select something yummy!"
              // supportedOrientations={['landscape']}
              accessible={true}
              optionContainerStyle={{ backgroundColor: 'white' }}
              scrollViewAccessibilityLabel={'Scrollable options'}
              cancelButtonAccessibilityLabel={'Cancel Button'}
              onChange={(option) => { this.setState({ storyPoints: option.label }) }}>

              <TextInput
                style={{ borderWidth: 1, borderColor: '#ccc', padding: 10, height: 50, width: '98%', marginLeft: '1%', color: 'black' }}
                editable={false}
                placeholder="Select Story Points!"
                value={this.state.storyPoints} />

            </ModalSelector>

            {/* <Picker
              // placeholder= "Acceptance Criteria/Definition of Done"
              selectedValue={this.state.storyPoints}
              style={{ height: 50, width: '98%' }}
              onValueChange={(storyPoints) => this.setState({ storyPoints: storyPoints })} >
              <Picker.Item label="1" value="1" />
              <Picker.Item label="2" value="2" />
              <Picker.Item label="3" value="3" />
              <Picker.Item label="5" value="5" />
              <Picker.Item label="8" value="8" />
              <Picker.Item label="13" value="13" />
            </Picker> */}

            <Text style={{ marginLeft: 10, paddingTop: 10 }}>Priority Level</Text>

            <ModalSelector
              data={data1}
              initValue="Select Priority  Points!"
              // supportedOrientations={['landscape']}
              accessible={true}
              optionContainerStyle={{ backgroundColor: 'white' }}
              scrollViewAccessibilityLabel={'Scrollable options'}
              cancelButtonAccessibilityLabel={'Cancel Button'}
              onChange={(option) => { this.setState({ priorityLevel: option.label }) }}>

              <TextInput
                style={{ borderWidth: 1, borderColor: '#ccc', padding: 10, height: 50, width: '98%', marginLeft: '1%', color: 'black' }}
                editable={false}
                placeholder="Select Priority  Points!"
                value={this.state.priorityLevel} />

            </ModalSelector>

            {/* <Picker
              // placeholder= "Acceptance Criteria/Definition of Done"
              selectedValue={this.state.priorityLevel}
              style={{ height: 50, width: '98%' }}
              onValueChange={(priorityLevel) => this.setState({ priorityLevel: priorityLevel })} >
              <Picker.Item label="1" value="1" />
              <Picker.Item label="2" value="2" />
              <Picker.Item label="3" value="3" />
              <Picker.Item label="4" value="4" />
              <Picker.Item label="5" value="5" />
            
            </Picker> */}

            <View style={{ flexDirection: 'row', marginTop: 10, justifyContent: "space-between" }}>
              <TouchableOpacity style={styles.opensave} onPress={this.addMainTask.bind(this)} disabled={this.state.itemPressedDisabled}>
                <Text style={{ color: 'white' }}>Add</Text>
              </TouchableOpacity>

            
              <TouchableOpacity style={styles.opensave} onPress = { this.saveTemplete.bind(this) } disabled={this.state.itemPressedDisabled}>
                <Text style={{ color: 'white' }}>Save as a Template</Text>
              </TouchableOpacity>
              {/* <TouchableOpacity style={styles.opencancel} onPress={() => this.props.navigation.goBack()}>
                <Text style={{ color: 'white' }}>CANCEL</Text>

              </TouchableOpacity> */}

            </View>
            <View style={{ flexDirection: 'row', marginTop: 10, justifyContent: "space-between" }}>
             
              <TouchableOpacity style={styles.openTemplate} onPress = { this.addSaveTemplete.bind(this) } disabled={this.state.itemPressedDisabled}>
                <Text style={{ color: 'white' }}>Add and Save as a Template</Text>
              </TouchableOpacity>
            

            </View>

          </View>
        </Content>
      </Container>
    );
  }
}
//Styles for UI
const styles = StyleSheet.create({
  opencancel: {
    flex: 1,
    ...Platform.select({
      ios: {
        backgroundColor: 'red', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
      android: {
        backgroundColor: 'red', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
    }),
  },
  opensave: {
    flex: 1,
    ...Platform.select({
      ios: {
        backgroundColor: 'green', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
      android: {
        backgroundColor: 'green', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
    }),
  },
  openTemplate: {
    flex: 1,
    ...Platform.select({
      ios: {
        backgroundColor: '#00A2C1', height: 30, width: 250, alignItems:
          "center", justifyContent: 'center'
      },
      android: {
        backgroundColor: '#00A2C1', margin: 20, height: 30, width: 250, alignItems:
          "center", justifyContent: 'center'
      },
    }),
  },
});