/*
FileName:AddMainTask.js
Version:1.0.0
Purpose:Modify the existing module
Devloper:Rishitha,Raju,Naveen,Harsha
*/
import React, { Component } from 'react';
import Requesteddata from '../AdminComponets/AdminRequestedDataProjects';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, LayoutAnimation, UIManager, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert, TouchableWithoutFeedback } from 'react-native';
import { Left, Button, Container, Header, Body, Title, Content, Item, Input, Right, Subtitle } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import SearchableDropdown from 'react-native-searchable-dropdown';
import Icon from 'react-native-vector-icons/FontAwesome';
import { API } from "../WebServices/RestClient";
import { Collapse, CollapseHeader, CollapseBody } from "accordion-collapse-react-native";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import Toast from 'react-native-whc-toast';
import { NavigationEvents } from 'react-navigation';
import moment from "moment";
import {
  BallIndicator,
  BarIndicator,
  DotIndicator,
  MaterialIndicator,
  PacmanIndicator,
  PulseIndicator,
  SkypeIndicator,
  UIActivityIndicator
} from 'react-native-indicators';
import {TASKNO,ASSIGNED_TO,ASSIGNED_BY,ADDSUBTASK,ADDMAINTASK ,TASKTITLE, DESCRIPTION, TARGETTIME, TASKSTATUS, TIMELEFT, MODIFY,VIEWSUBTASK,DELETE} from '../CommonComponents/Header';

FOOTER_MAX_HEIGHT = 50
FOOTER_MIN_HEIGHT = 40

class ListItem extends React.Component {

  constructor(props) {
    super(props)

    this.state = {
      expanded: false,
      deletevisibility: false
    }
    if (Platform.OS === 'android') {
      UIManager.setLayoutAnimationEnabledExperimental(true);
    }
  }
  changeLayout = () => {
    LayoutAnimation.configureNext(LayoutAnimation.Presets.easeInEaseOut);
    this.setState({ expanded: !this.state.expanded });
  }
  componentDidMount() {

    this.VisibleActions();
  }
  //Visable actions by role
  async VisibleActions() {

    AsyncStorage.getItem("emp_role", (err, res) => {

      //Alert.alert(res);

      if (res == 'Emp' || res == 'Manager' || res == 'Approver') {

        this.setState({ deletevisibility: true });
      } else {

        this.setState({ deletevisibility: false });
      }

    });

  }



  render() {
    const { item } = this.props;

   

    return (
      <View>
        <View style={[item.taskStatus == 100 ? styles.container1 : styles.container]}>
          <View style={styles.boxheader}>
            {/* <Collapse style={styles.container}> */}
            {/* <Collapse style={[item.taskStatus ==100 ? styles.container1 : styles.container]}> */}
            <TouchableOpacity activeOpacity={0.8} onPress={this.changeLayout} >
              {/* <CollapseHeader style={styles.boxheader}> */}



              <View style={{ flexDirection: 'row' }}>
                {/* <Text style={styles.signUpText0} >{TASKNO}:</Text> */}
                <Text style={styles.signUpText1} >{item.fullName}</Text>
                <Text style={styles.signUpText2}>{moment(item.statusDate).format('MM.DD.YYYY hh:mm:ss')}
                 
                </Text>
              </View>




              <View style={{ flexDirection: 'row', paddingRight: 25, width: wp('90%') }}>
                {/* <Text style={styles.signUpText4} >{TASKTITLE}:</Text> */}
                <Text style={styles.signUpText3text} >{item.message}</Text>
              </View>

              {/* </CollapseHeader> */}
            </TouchableOpacity>
            {/* </Collapse> */}
          </View>
        </View>
        <View style={{ backgroundColor: '#474545', height: 1 }}>
        </View>
      </View>
    )
  }
}

export default class AddMainTask extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      open: false,
      ProjectTitle: "",
      ProjectDescription: "",
      role: '',
      userToken: '',
      isLoading: true,
      dataSource: [],
      isFetching: false,
      modalVisible: false,
      addTask: 'add',
      modifyTask: 'modify',
      storyId: this.props.navigation.state.params.subtaskid,//getting module id
      ideaid: this.props.navigation.state.params.ideaid,//getting idea id
      moduledesc: this.props.navigation.state.params.moduledesc,//getting moduledesc
      idea_title: this.props.navigation.state.params.idea_title,//getting ideatitle
      dependencyid: 'NA',
      person: '',
      subTask: '',
      description: '',
      days: '',
      time: '',
      error1: '', error2: '', error3: '', error4: '', error5: '',

    };
  }

  //getting the role and id 
  modalDidOpen = () => {
    AsyncStorage.getItem("role", (err, res) => {
      this.setState({ role: res });

    });
    AsyncStorage.getItem("userToken", (err, res) => {
      this.setState({ userToken: res });

    });

  }


  componentDidMount() {
    log("Debug", "Main Task Screen is loaded");
    this.add();


  }
  //Dialog actions end

  //get ModuleList
  add() {

    this.getCommentUserStory();
  }
  //Refresh the maintask list
  onRefresh() {
    this.setState({
      // dataSource: [],
    })
    this.add();
  }


  //getCommentUserStory for Projects
  getCommentUserStory() {

    const { storyId } = this.state;
   console.warn("storyId"+storyId)

   

    AsyncStorage.getItem("cropcode", (err, res) => {
      log("Info", " getCommentUserStory(cropcode) is used to get all module list");

      const cropcode = res;

      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          log("Warn", "No internet connection");
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',

            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'story_comments.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({

                storyId: storyId,
                corp: cropcode,
                action:"get_story_comment"
              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
                //  alert(JSON.stringify(responseJson));


              console.log(responseJson)
              //  this.refs.toast.showBottom('Main Task Added');
              this.setState({
                isLoading: false,

                dataSource: responseJson.data,
                isFetching: false
              }, function () {

              });
            })
            .catch((error) => {
              console.error(error);
              log("Error", "Adding project error");
            });
        }
      });
      //this.refs.toast.showCenter('Main Task Added');
    });

  }
  







  FlatListItemSeparator = () => {
    return (
      <View
        style={{
          //  height: .5,
          width: "100%",
          backgroundColor: "#000",
        }}
      />
    );
  }



  _listEmptyComponent = () => {
    return (
      <View style={{ width: '90%', height: '80%' }}>
        <Text></Text>
      </View>
    )
  }

  render() {
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }

    return (
      <Container>
        <Header
          androidStatusBarColor="#00A2C1"
          style={{
            backgroundColor: '#00A2C1',
            height: 60,
            width: Dimensions.get('window').width,
            borderBottomColor: '#ffffff',
            justifyContent: 'space-between',
          }}>
          <Left>
            <Icon size={20} name="arrow-left" style={{ color: '#fff' }} onPress={() =>
              this.props.navigation.goBack(null)} />

          </Left>
          {/* <Body style={{ width: wp('100%') }}> */}
            <Text style={{ color: '#fff', fontWeight: '600',marginTop:25,marginRight:150 }}>UserStory/Backlog History</Text>
            {/* <Subtitle style={{ color: '#fff', fontWeight: '600' }}>{this.state.moduledesc}</Subtitle> */}
          {/* </Body> */}
          {/* <Right></Right> */}
        </Header>
        <View style={styles.MainContainer}>
          <NavigationEvents
            onDidFocus={() => this.onRefresh()}
          />
          <Toast ref="toast" />
          <View style={{ height: '90%' }}>

            <FlatList

              extraData={this.state}
              keyExtractor={this._keyExtractor}
              renderItem={this._renderItem}

              data={this.state.dataSource}

              onRefresh={() => this.onRefresh()}
              refreshing={this.state.isFetching}

              ItemSeparatorComponent={this.FlatListItemSeparator}
              renderItem={({ item, index }) =>
                <View>

                  <ListItem navigation={this.props.navigation}
                    item={item}
                  />
                </View>
              }
              keyExtractor={item => item.id}
              ListEmptyComponent={this._listEmptyComponent}
            />

          </View>
         
        </View>
      </Container>

    );

  }

}
const styles = StyleSheet.create(
  {
    MainContainer:
    {
      paddingTop: 4,
      flex: 1,
      width: Dimensions.get('window').width,
      height: Dimensions.get('window').height,
      backgroundColor: '#F8F8F8'
    },


    textStyle: {
      color: '#fff',
      fontSize: 18,
      backgroundColor: '#00a2c1',
      paddingLeft: 10,
      paddingRight: 10,
      // paddingBottom: 5,
      paddingTop: 5,
      borderRadius: 5,
    },
    container: {
      flex: 1,
      width: '100%',
      paddingLeft: hp('2%'),
      backgroundColor: '#fff'
    },
    container1: {
      flex: 1,
      width: '100%',
      paddingLeft: hp('2%'),
      // backgroundColor: '#EAFAF1',
      backgroundColor:'#dcf2cb',
    },
    footer: {
      position: 'absolute',
      flex: 0.1,
      left: 0,
      right: 0,
      bottom: -10,
      backgroundColor: 'green',
      flexDirection: 'row',
      height: 80,
      alignItems: 'center',
    },
    bottomButtons: {
      alignItems: 'center',
      justifyContent: 'center',
      flex: 1,
    },
    footerText: {
      color: 'white',
      fontWeight: 'bold',
      alignItems: 'center',
      fontSize: 18,
    },
    buttonContainer: {
      width: wp('90%'),
      alignSelf: 'baseline',
      marginBottom: 10,
      color: '#d2691e',
      marginLeft: 4,



    },
    signupButton: {

      backgroundColor: '#ffffff',
    },
    subcontainer: {
      flex: 2,
      flexDirection: 'row',
      paddingTop: 40
    },
    signUpText0: {
      fontSize: 13,
      color: 'green',
      paddingTop: 10,
      // fontWeight:'bold'

    },
    signUpText1: {
      fontSize: 13,
      color: 'green',
      paddingTop: 10,
      // fontWeight:'bold',
      width: '45%',

    },
    end: {

      alignItems: 'flex-end',

    },
    end1: {
      flex: 2,
      height: '50%',
      paddingTop: 20,
      justifyContent: 'space-between',

      flexDirection: 'row',
    },
    s: {
      justifyContent: 'center',

      backgroundColor: '#ed7070',
      shadowOffset: { width: 50, height: 50 },
      alignItems: 'center',
      width: wp('40%'),
      height: hp('12%'),

    },
    signUpText2: {
      fontSize: 10,
      fontSize: 13,
      color: 'black',
      paddingTop: 10,
      // color:'#c0c0c0'

      //  marginRight: 10,
      //textAlign: "right"

    },
    signUpText3: {

      fontSize: 12,
      paddingTop: 10,
      paddingLeft: 5,
      //width: '50%',
      color: 'black',
      // alignItems: 'center',
    },
    signUpText3text: {
      color: 'black',
      fontSize: 12,
      paddingTop: 10,
    //   paddingLeft: 10,
      //fontWeight: 'bold',


      alignItems: 'center',
    },


    signUpText03: {
      width: '25%',
      fontSize: 12,
      paddingTop: 10,
      paddingLeft: 10,
      color: 'black',

      alignItems: 'center',
    },
    signUpText4: {
      fontSize: 12,
      paddingTop: 10,
      color: 'black',


      //alignItems: 'center',
    },
    listgap: {
      fontSize: 12,
      paddingTop: 10,
      color: 'black',


      alignItems: 'center',
    },


    listgap1: {
      fontSize: 12,
      paddingTop: 10,
      paddingLeft: 70,
      color: 'black',
      // paddingRight:40,

      alignItems: 'center',
    },
    signup: {
      //paddingTop:20,
      color: "#FFF",

    },
    boxone: {
      flex: 1,
      marginTop: 5,

    },
    boxtwo: {
      flex: 1,

    },
    boxthree: {
      flex: 1,

    },
    box1: {
      justifyContent: 'space-between',
      flexDirection: 'row',
      position: 'relative',
      // marginBottom: 10,

    },
    box: {
      flexDirection: 'row',
      position: 'relative',
      marginBottom: 10,


    },
    signUpText: {
      fontSize: 20,
      justifyContent: 'center',


      color: 'white',
      alignSelf: 'center',
    },
    boxheader: {
      justifyContent: 'space-between',
      flexDirection: 'column',
      position: 'relative',
      marginBottom: 5,

    },
  
   
  });