/*
FileName:GroupChat.js
Version:1.0.0
Purpose:Getting the List of group messages with GroupName and List of Group Members and also send Message
Devloper:Mahesh
*/

import React, { Component } from 'react';
import {
  StyleSheet,
  Text,
  View,
  TouchableOpacity,
  Image,
  Alert,
  ScrollView,
  TextInput,
  FlatList,
  Button,
  Dimensions,
  KeyboardAvoidingView,
  TouchableWithoutFeedback,
  Keyboard
} from 'react-native';
import Icon from 'react-native-vector-icons/FontAwesome';
import AsyncStorage from '@react-native-community/async-storage';

import { Title, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab, Subtitle } from 'native-base';

import NetInfo from '@react-native-community/netinfo';
import { API, CHATAPI } from "../WebServices/RestClient";
import log from '../LogFile/Log';
import { EMPLOYEEID } from './Header';

import moment from "moment";
import { DataTable } from 'react-native-paper';
import { launchCamera, launchImageLibrary } from 'react-native-image-picker';
import ImageZoom from 'react-native-image-pan-zoom';

const options = {
  title: 'Select Image',
  type: 'library',
  options: {
    maxHeight: 200,
    maxWidth: 200,
    selectionLimit: 1,
    mediaType: 'photo',
    includeBase64: false
  },
}
export default class GroupChat extends Component {

  constructor(props) {
    super(props);
    this.state = {
      message: '',
      dataSource: [],
      itemPressedDisabled: false,
      subtaskId: this.props.navigation.state.params.id,
      // action: this.props.navigation.state.params.action,
      sno: this.props.navigation.state.params.sno,
      userid: '',
      groupName: this.props.navigation.state.params.group_name,
      members_name: this.props.navigation.state.params.members_name,
      members_email: this.props.navigation.state.params.members_email,
      groupList: '',
      handleHover: false,
      commentDetails: {},
      SendImg: false,
      open: false
    };
  }

  componentDidMount() {
    log("Debug", "Task Chat screen is loaded");
    // this.groupMembersList();//Getting the List of GroupMembers
    this.getMessages();//Getting the List of Messages based pn Task
    this.updateMessages();//Update the chat count
    // this.groupMembersEmail();//Getting the List of GroupMembers Emails
    // alert(JSON.stringify(this.props.navigation.state.params.sno))
  }

  openModal = (item) => {
    // alert(JSON.stringify(item))
    this.setState({

        open: true,
        image: item
    })
}
imageClose = () => {

    this.setState({
        open: false,

    })
}
  //getting task related group members added by naveen
  groupMembersList() {
    log("Info", " groupMembersList(role, userToken, cropcode) is used getting task related group members");
    // alert(this.state.action)
    const groupId = this.state.subtaskId;
    console.warn("taskid" + groupId)
    // alert(groupId)
    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];


      this.setState({ userid: userToken });

      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        }
        else {
          fetch(API + 'user_story_details.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                action: this.state.action,
                corp_code: cropcode,
                groupId: groupId

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn("Hello" + JSON.stringify(responseJson))
              // alert("Hello" + JSON.stringify(responseJson))
              //Getting the Group details for Subtask start
              if (responseJson.status === 'True' && responseJson.task == 'subtask') {

                const al = [];
                // al.push(responseJson.ideaByName);
                al.push(responseJson.acceptedByName);
                al.push(responseJson.ideaModfiedName);
                al.push(responseJson.releaseOwner);
                al.push(responseJson.rejectedByName);
                al.push(responseJson.moduleCreatedBy);
                al.push(responseJson.moduleModifiedBy);
                al.push(responseJson.mainAssignedBy);
                al.push(responseJson.mainAssignedTo);
                al.push(responseJson.mainModifiedBy);
                al.push(responseJson.subAssignedBy);
                al.push(responseJson.subAssignedTo);
                al.push(responseJson.subModifiedBy);
                // al.push('admin');
                al.push('Admin(admin)');
                this.setState({
                  groupName: responseJson.subTaskId
                })

                // const k = (al);
                // function getUnique(array) {

                //   var uniqueArray = [];

                //   // Loop through array values

                //   for (var value of array) {

                //     if (uniqueArray.indexOf(value) === -1) {

                //       uniqueArray.push(value);
                //     }
                //   }

                //   return uniqueArray;
                // }
                // console.warn(k);
                const k = (al);
                function getUnique(array) {
                  var uniqueArray = [];
                  // Loop through array values
                  for (var value of array) {
                    if (uniqueArray.indexOf(value) === -1) {
                      if (value !== "NA") {
                        uniqueArray.push(value);
                      }
                    }
                  }
                  return uniqueArray;
                }

                var uniqueNames = getUnique(k);
                console.warn(uniqueNames)
                var h = uniqueNames;

                // var details = "admin";
                var details = "Admin(admin)";
                // for (var i = 0; i < h.length - 1; i++) {//Checking the group list
                for (var i = 1; i <= h.length; i++) {//Checking the group list

                  // if (h[i] === "NA" || h[i] == "admin") { //Remove Duplicate list
                  //   h.splice(i, 2);
                  // }

                  if (h[i] === "Admin(admin)") { //Remove Duplicate list
                    h.splice(i, 1);
                  }

                  //Concat List of Group Members
                  details = details + "," + h[i - 1];
                  this.setState({
                    groupList: details
                    // groupList: details.replace("Admin(admin),", "")
                  })
                  //alert(details);
                }

                this.setState({
                  groupName: responseJson.subTaskId,
                });

              }
              //Getting the Group details for Subtask end

              //Getting the Group details for Maintask start
              else if (responseJson.status === 'True' && responseJson.task == 'maintask') {
                const al = [];
                al.push(responseJson.ideaByName);
                al.push(responseJson.acceptedByName);
                al.push(responseJson.ideaModfiedName);
                al.push(responseJson.releaseOwner);
                al.push(responseJson.rejectedByName);
                al.push(responseJson.moduleCreatedBy);
                al.push(responseJson.moduleModifiedBy);
                al.push(responseJson.mainAssignedBy);
                al.push(responseJson.mainAssignedTo);
                al.push(responseJson.mainModifiedBy);
                al.push('Admin(admin)');
                this.setState({
                  groupName: responseJson.subTaskId
                })

                const k = (al);
                function getUnique(array) {

                  var uniqueArray = [];

                  // Loop through array values

                  for (var value of array) {

                    // if (uniqueArray.indexOf(value) === -1) {

                    //   uniqueArray.push(value);
                    // }
                    if (uniqueArray.indexOf(value) === -1) {
                      if (value !== "NA") {
                        uniqueArray.push(value);
                      }
                    }
                  }

                  return uniqueArray;
                }
                // console.warn("Naveen"+k);
                var uniqueNames = getUnique(k);
                console.warn(uniqueNames)
                var h = uniqueNames;
                console.warn(h.length)
                details = "Admin(admin)";
                for (var i = 1; i < h.length; i++) {//Checking the group list
                  if (h[i] === "Admin(admin)") { //Remove duplicate list
                    h.splice(i, 1);
                  }

                  //Concat List of Group Members
                  details = details + "," + h[i - 1];
                  console.warn("Details" + details)
                  this.setState({
                    groupList: details.replace("Admin(admin),", "")
                  })
                  // alert(details);
                }

                this.setState({
                  groupName: responseJson.subTaskId,

                });
              }//Getting the Group details for maintask end
              else {

              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "Task Chat maintask group Menbers error");
            });

        }
      });
    });

  }

  //getting task related group members emails added by mahesh
  groupMembersEmail() {
    log("Info", " groupMembersEmail(role, userToken, cropcode) is used getting task related group members emails");
    //alert(this.state.action)
    const groupId = this.state.subtaskId;
    console.warn("taskid" + groupId)
    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];


      this.setState({ userid: userToken });

      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        }
        else {
          fetch(API + 'user_story_details1.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                action: this.state.action,
                corp_code: cropcode,
                groupId: groupId

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn("Hello" + JSON.stringify(responseJson))
              // alert("Hello"+JSON.stringify(responseJson))
              //Getting the Group details for Subtask start
              if (responseJson.status === 'True' && responseJson.task == 'subtask') {

                const al = [];
                al.push(responseJson.ideaByName);
                al.push(responseJson.acceptedByName);
                al.push(responseJson.ideaModfiedName);
                al.push(responseJson.releaseOwner);
                al.push(responseJson.rejectedByName);
                al.push(responseJson.moduleCreatedBy);
                al.push(responseJson.moduleModifiedBy);
                al.push(responseJson.mainAssignedBy);
                al.push(responseJson.mainAssignedTo);
                al.push(responseJson.mainModifiedBy);
                al.push(responseJson.subAssignedBy);
                al.push(responseJson.subAssignedTo);
                al.push(responseJson.subModifiedBy);
                // al.push('admin');
                al.push('Admin(admin)');
                this.setState({
                  groupName: responseJson.subTaskId
                })

                // const k = (al);
                // function getUnique(array) {

                //   var uniqueArray = [];

                //   // Loop through array values

                //   for (var value of array) {

                //     if (uniqueArray.indexOf(value) === -1) {

                //       uniqueArray.push(value);
                //     }
                //   }

                //   return uniqueArray;
                // }
                // console.warn(k);
                const k = (al);
                function getUnique(array) {
                  var uniqueArray = [];
                  // Loop through array values
                  for (var value of array) {
                    if (uniqueArray.indexOf(value) === -1) {
                      if (value !== "NA") {
                        uniqueArray.push(value);
                      }
                    }
                  }
                  return uniqueArray;
                }

                var uniqueNames = getUnique(k);
                console.warn(uniqueNames)
                var h = uniqueNames;

                // var details = "admin";
                var details = "Admin(admin)";
                // for (var i = 0; i < h.length - 1; i++) {//Checking the group list
                for (var i = 1; i <= h.length; i++) {//Checking the group list

                  // if (h[i] === "NA" || h[i] == "admin") { //Remove Duplicate list
                  //   h.splice(i, 2);
                  // }

                  if (h[i] === "Admin(admin)") { //Remove Duplicate list
                    h.splice(i, 1);
                  }

                  //Concat List of Group Members
                  details = details + "," + h[i - 1];
                  this.setState({
                    groupList: details
                  })
                  //alert(details);
                }

                this.setState({
                  groupName: responseJson.subTaskId,
                });

              }
              //Getting the Group details for Subtask end

              //Getting the Group details for Maintask start
              else if (responseJson.status === 'True' && responseJson.task == 'maintask') {
                const al = [];
                al.push(responseJson.ideaByName);
                al.push(responseJson.acceptedByName);
                al.push(responseJson.ideaModfiedName);
                al.push(responseJson.releaseOwner);
                al.push(responseJson.rejectedByName);
                al.push(responseJson.moduleCreatedBy);
                al.push(responseJson.moduleModifiedBy);
                al.push(responseJson.mainAssignedBy);
                al.push(responseJson.mainAssignedTo);
                al.push(responseJson.mainModifiedBy);
                al.push('Admin(admin)');
                this.setState({
                  groupName: responseJson.subTaskId
                })

                const k = (al);
                function getUnique(array) {

                  var uniqueArray = [];

                  // Loop through array values

                  for (var value of array) {

                    // if (uniqueArray.indexOf(value) === -1) {

                    //   uniqueArray.push(value);
                    // }
                    if (uniqueArray.indexOf(value) === -1) {
                      if (value !== "NA") {
                        uniqueArray.push(value);
                      }
                    }
                  }

                  return uniqueArray;
                }
                // console.warn("Naveen"+k);
                var uniqueNames = getUnique(k);
                console.warn(uniqueNames)
                var h = uniqueNames;
                console.warn(h.length)
                details = "Admin(admin)";
                for (var i = 1; i < h.length; i++) {//Checking the group list
                  if (h[i] === "Admin(admin)") { //Remove duplicate list
                    h.splice(i, 1);
                  }

                  //Concat List of Group Members
                  details = details + "," + h[i - 1];
                  console.warn("Details" + details)
                  this.setState({
                    // groupEmail: details.replace("Admin(admin),", "")
                    groupEmail: al
                  })
                  // alert(this.state.groupEmail);
                }

                // this.setState({
                //   groupEmail: responseJson.subTaskId,

                // });
                // alert(this.state.groupEmail)
              }//Getting the Group details for maintask end
              else {

              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "Task Chat maintask group Menbers error");
            });

        }
      });
    });

  }

  //getting task related messages
  getMessages() {
    // alert("test"+this.state.subtaskId)
    log("Info", " getMessages(role, userToken, cropcode) is used getting task related messages");
    const groupId = this.state.subtaskId;
    console.warn("groupid" + groupId);

    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      this.setState({ userid: userToken });

      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        }
        else {
          fetch(API + 'group_chat.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                action: 'getmessages',
                corp_code: cropcode,
                group_Id: groupId

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(responseJson)

              if (responseJson.status === 'True') {
                console.warn(responseJson);
                this.setState({
                  dataSource: responseJson.data.reverse(),
                });
              } else {
                this.setState({
                  dataSource: '',
                });
              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "getting task related messages error");
            });

        }
      });
    });
  }


  //update task related messages
  updateMessages() {
    log("Info", " updateMessages(role, userToken, cropcode) is used to update task related messages");
    const groupId = this.state.subtaskId;
    const sno = this.state.sno;
    console.warn("sno" + sno)
    // alert("sno" + sno)

    const msgId = sno ? sno.map((msgId, index) => {
      return msgId.sno
    }) : null
    // console.warn("Sno of the data"+this.props.navigation.state.params.sno)

    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      this.setState({ userid: userToken });

      NetInfo.fetch().then(state => {
        if (state.type == "none") {
          log("Warn", "No internet connection");
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        }
        else {
          fetch(API + 'group_chat.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                action: 'updateChat',
                corp_code: cropcode,
                messagedBy: userToken,

                msgId: msgId ? msgId : " "
                // groupId: groupId

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn("update chat" + JSON.stringify(responseJson))


            })
            .catch((error) => {
              console.error(error);
              log("Error", "getting task related messages error");
            });

        }
      });
    });
  }
  //Sending Message without empty data added by naveen on 11 Nov
  sendMessageText() {
    if (this.state.message == 0) {
      alert("please type message")
      log("Warn", "message should not be empty");
    }
    else {
      this.sendMessage()
    }
  }
  //send messages
  sendMessage() {
    AsyncStorage.getItem("groupEmail", (err, res) => {
      this.setState({ groupEmail: res });
      log("Info", " sendMessage(role, userToken, cropcode) is used to send messages");
      const message = this.state.message;
      const groupId = this.state.subtaskId;
      const groupEmail = Array.from(new Set(this.state.groupEmail));
      // alert(groupEmail)
      console.warn("emails" + groupEmail)
      // alert("emails"+this.state.members_email)
      // alert(this.state.groupName)

      AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
        const cropcode = response[0][1];
        const userToken = response[1][1];
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          this.setState({ itemPressedDisabled: true })
          fetch(API + 'group_chat.php', {
            method: 'POST',
            headers: {
              'Accept': 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({

              action: 'send',
              group_Id: groupId,
              corp_code: cropcode,
              message: message,
              messagedBy: userToken,
              group_name: this.state.groupName,
              groupEmail: this.state.members_email,
              projectId: projectId,
              reply_id: this.state.commentDetails.id ? this.state.commentDetails.id : ""

            })
          }).then((response) => response.json())
            .then((responseJson) => {
              this.getMessages();
              this.setState({
                message: '',
                itemPressedDisabled: false,
                handleHover: false
              });
              //message:this.state.message=''
            }).catch((error) => {
              console.error(error);
              log("Error", "send message error");
            });
        });
      });
    });
  }
  attach1() {
    // alert("clicked")
    const images1 = this.state.images;

    console.log(images1.assets[0])
    const message = this.state.message;
    const groupId = this.state.subtaskId;
    AsyncStorage.multiGet(["cropcode", "userToken"], async (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      AsyncStorage.getItem("projectId", async (err, res) => {
        const projectId = res;
        const data = new FormData()
        data.append('file', {
          uri: images1.assets[0].uri,
          type: images1.assets[0].type,
          name: images1.assets[0].fileName,
        })
        data.append('message', this.state.message)
        data.append('action', 'media')
        data.append('corp_code', cropcode)
        data.append('groupId', groupId)
        data.append('messagedBy', userToken)
        data.append('api', CHATAPI)
        data.append('groupName', this.state.groupName);
        data.append('groupEmail', this.state.members_email);
        data.append('reply_id', this.state.commentDetails.id ? this.state.commentDetails.id : "")



        let res1 = await fetch(API + 'group_chat1.php',
          {
            method: 'post',
            body: data,
            headers: {
              'Content-Type': 'multipart/form-data; ',
            },
          }
        );
        let responseJson = await res1.json();
        this.getMessages();
        this.setState({
          handleHover: false,
          uri: null,
          SendImg: false,
          message: '',
          // commentDetails:null

        })
        alert("Image Uploaded successfully")
      });
    });
  }
  attach = async () => {
    // alert("clicked")
    const images = await launchImageLibrary(options);
    this.setState({
      images: images,
      uri: images.assets[0].uri,
      SendImg: true
    })
    // alert("images" + JSON.stringify(this.state.images))


  }

  renderDate = (date) => {
    return (
      <Text style={styles.time}>
        {date}
      </Text>
    );
  }

  handlecom = (comment) => {

    this.setState({
      handleHover: true,
      commentDetails: comment
    })
  }
  handlecomClose = () => {

    this.setState({
      handleHover: false,
      uri: null,
      SendImg: false,
      reply_id: ''

    })
  }

  render() {

    return (
      <KeyboardAvoidingView
        behavior={Platform.OS === "ios" ? "padding" : "height"}
        style={styles.container}
      >
        {/* <TouchableWithoutFeedback onPress={Keyboard.dismiss}> */}

        <Container>
          <Header
            androidStatusBarColor="#00A2C1"
            style={{
              backgroundColor: '#00A2C1',
              height: 100,
              width: Dimensions.get('window').width,
              borderBottomColor: '#ffffff',
              justifyContent: 'space-between',
            }}>

            <Icon name="arrow-left" size={20} style={{ color: '#fff', paddingTop: 15 }}
              onPress={() =>
                this.props.navigation.goBack()} />
            <Body style={{ paddingLeft: 10, }}>
              <Title>{this.state.groupName}</Title>
              <Text style={{ fontSize: 12, color: 'white' }}>{this.state.members_name}</Text>
            </Body>

          </Header>
          {/* <KeyboardAvoidingView> */}
          {this.state.open === true ?
            <View style={{ flex: 1, alignItems: "center", height: '100%', width: '100%', justifyContent: 'center' }}>
              <ImageZoom
                cropWidth={Dimensions.get('window').width}
                cropHeight={600}
                imageWidth={600}
                imageHeight={600}>
                <Image source={{ uri: this.state.image.path }} resizeMode='contain' style={{ width: "90%", height: "80%", }} />

              </ImageZoom>
              <TouchableOpacity onPress={() => this.imageClose()} ><Text>Close</Text></TouchableOpacity>

            </View> :
            <View style={styles.container}>
              <ScrollView
                horizontal={true}
                showsHorizontalScrollIndicator={false}
              // ref={ref => { this.scrollView = ref }}
              // onContentSizeChange={() => this.scrollView.scrollToEnd({ y: 0, animated: false })}
              >


                <FlatList style={styles.list}
                  inverted

                  data={this.state.dataSource}
                  keyExtractor={(item) => {
                    return item.id;
                  }}
                  renderItem={(message) => {
                    const item = message.item;
                    let inMessage = item.messagedBy === this.state.userid;
                    let itemStyleSingle = !inMessage ? styles.itemInSingle : styles.itemOutSingle;
                    let itemStyle = !inMessage ? styles.itemIn : styles.itemOut;
                    let itemStyleReply = !inMessage ? styles.itemInReply : styles.itemOutReply;
                    // const left = <View style={{flexDirection:'row'}}><Text style={{ fontSize: 12, color: 'orange' }}>{item.username}</Text><Icon color={'#C0C0C0'} size={25} style={{ marginLeft: 10 }} name="reply" /></View>
                    // const right = <View style={{flexDirection:'row'}}><Text style={{ fontSize: 12, color: 'blue' }}>{item.username}</Text><Icon color={'#C0C0C0'} size={25} style={{ marginLeft: 10 }} name="reply" /></View>
                    return (
                      <ScrollView>


                        { item.reply_message !== null ?
                          <View>
                            <View style={[styles.itemReply, itemStyleReply]}>
                              <View style={{ padding: 5, }}>
                                {itemStyle === styles.itemOut ? <View style={{ flexDirection: 'row' }}><Text style={{ fontSize: 12, color: 'orange' }}>{item.reply_username}</Text></View> : <View style={{ flexDirection: 'row' }}><Text style={{ fontSize: 12, color: 'blue' }}>{item.username}</Text></View>}
                                {item.reply_path !== "" ? <TouchableOpacity onPress={() => this.openModal(item)} ><Image source={{ uri: item.reply_path }} style={{ width: 210, height: 50 }} /></TouchableOpacity> : null}
                                <Text style={{ width: 210 }} selectable={true} key={Math.random()}>{item.reply_message}</Text>
                                {!inMessage && this.renderDate(moment(item.messagedTime).format('MM.DD.YYYY hh:mm:ss'))}
                                {inMessage && this.renderDate(moment(item.messagedTime).format('MM.DD.YYYY hh:mm:ss'))}
                              </View>
                            </View>

                            <View style={[styles.item, itemStyle]}>
                              <View style={{ padding: 5, }}>
                                {itemStyle === styles.itemOut ? <View style={{ flexDirection: 'row' }}><Text style={{ fontSize: 12, color: 'orange' }}>{item.username}</Text><TouchableOpacity onPress={() => this.handlecom(item)} ><Icon color={'#C0C0C0'} size={25} style={{ marginLeft: 10 }} name="reply" /></TouchableOpacity></View> : <View style={{ flexDirection: 'row' }}><Text style={{ fontSize: 12, color: 'blue' }}>{item.username}</Text><TouchableOpacity onPress={() => this.handlecom(item)} ><Icon color={'#C0C0C0'} size={25} style={{ marginLeft: 10 }} name="reply" /></TouchableOpacity></View>}
                                {item.path !== "" ? <TouchableOpacity onPress={() => this.openModal(item)} ><Image source={{ uri: item.path }} style={styles.imageview} /></TouchableOpacity> : null}
                                <Text style={{ width: 210 }} selectable={true} key={Math.random()}>{item.message}</Text>
                                {!inMessage && this.renderDate(moment(item.messagedTime).format('MM.DD.YYYY hh:mm:ss'))}
                                {inMessage && this.renderDate(moment(item.messagedTime).format('MM.DD.YYYY hh:mm:ss'))}
                              </View>
                            </View>
                          </View>
                          :
                          // <Text>hello</Text>
                          <View style={[styles.itemSingle, itemStyleSingle]}>
                            <View style={{ padding: 5, }}>
                              {itemStyle === styles.itemOut ? <View style={{ flexDirection: 'row' }}><Text style={{ fontSize: 12, color: 'orange' }}>{item.username}</Text><TouchableOpacity onPress={() => this.handlecom(item)} ><Icon color={'#C0C0C0'} size={25} style={{ marginLeft: 10 }} name="reply" /></TouchableOpacity></View> : <View style={{ flexDirection: 'row' }}><Text style={{ fontSize: 12, color: 'blue' }}>{item.username}</Text><TouchableOpacity onPress={() => this.handlecom(item)} ><Icon color={'#C0C0C0'} size={25} style={{ marginLeft: 10 }} name="reply" /></TouchableOpacity></View>}
                              {item.path !== "" ? <TouchableOpacity onPress={() => this.openModal(item)} ><Image source={{ uri: item.path }} style={styles.imageview} /></TouchableOpacity> : null}
                              <Text style={{ width: 210 }} selectable={true} key={Math.random()}>{item.message}</Text>
                              {!inMessage && this.renderDate(moment(item.messagedTime).format('MM.DD.YYYY hh:mm:ss'))}
                              {inMessage && this.renderDate(moment(item.messagedTime).format('MM.DD.YYYY hh:mm:ss'))}
                            </View>
                          </View>

                        }

                      </ScrollView>
                    )
                  }} />
              </ScrollView>

              {this.state.uri && <View style={{ width: "100%", height: 100, backgroundColor: 'grey', flexDirection: 'row' }}>
                <View style={{ width: '90%' }}>
                  < Image
                    source={{ uri: this.state.uri }}
                    style={{ width: 100, height: 100, resizeMode: 'contain' }}
                  />
                </View>
                <View>
                  <TouchableOpacity onPress={() => this.handlecomClose()} ><Icon color={'#fff'} size={25} style={{ marginLeft: 10, marginTop: 5 }} name="times-circle-o" /></TouchableOpacity>
                </View>
              </View>}

              <View style={this.state.handleHover === true ? styles.footer1 : styles.footer}>
                {this.state.handleHover === true ?
                  // alert(JSON.stringify(this.state.commentDetails))
                  < View >
                    <View style={styles.itemBottom}>
                      <View style={{ width: "90%" }}>
                        <Text style={{ fontSize: 12, color: 'green' }}>{this.state.commentDetails.username}</Text>
                        <Text style={{ fontSize: 12, color: 'black' }}>{this.state.commentDetails.message}</Text>
                      </View>
                      <TouchableOpacity onPress={() => this.handlecomClose()} ><Icon color={'#000'} size={25} style={{ marginLeft: 10, marginTop: 5 }} name="times-circle-o" /></TouchableOpacity>
                    </View>
                    <View style={{ flexDirection: 'row' }}>
                      <View style={styles.inputContainer}>
                        <TextInput style={styles.inputs}
                          autoFocus={true}
                          placeholder="Message"
                          underlineColorAndroid='transparent'
                          multiline={true}
                          onChangeText={(value) => this.setState({ message: value })}
                          value={this.state.message} />

                        <TouchableOpacity style={{ top: -5, right: 15 }} onPress={this.attach}>
                          <Image source={require('../Images/paperclip.png')} style={styles.iconSendfile} />
                        </TouchableOpacity>
                      </View>
                      {this.state.SendImg === false ?
                        <TouchableOpacity style={styles.btnSend} disabled={this.state.itemPressedDisabled} onPress={() => { this.sendMessageText() }}>
                          <Image source={require('../Images/sent.png')} style={styles.iconSend} />
                        </TouchableOpacity>
                        :
                        <TouchableOpacity style={styles.btnSend} disabled={this.state.itemPressedDisabled} onPress={() => { this.attach1() }}>
                          <Image source={require('../Images/sent.png')} style={styles.iconSend} />
                        </TouchableOpacity>
                      }


                    </View>

                  </View> :
                  <View style={{ flexDirection: 'row' }}>
                    <View style={styles.inputContainer}>
                      <TextInput style={styles.inputs}
                        // autoFocus={true}
                        placeholder="Message"
                        underlineColorAndroid='transparent'
                        multiline={true}
                        onChangeText={(value) => this.setState({ message: value })}
                        value={this.state.message} />

                      <TouchableOpacity style={{ top: -5, right: 15 }} onPress={this.attach}>
                        <Image source={require('../Images/paperclip.png')} style={styles.iconSendfile} />
                      </TouchableOpacity>
                    </View>
                    {this.state.SendImg === false ?
                      <TouchableOpacity style={styles.btnSend} disabled={this.state.itemPressedDisabled} onPress={() => { this.sendMessageText() }}>
                        <Image source={require('../Images/sent.png')} style={styles.iconSend} />
                      </TouchableOpacity>
                      :
                      <TouchableOpacity style={styles.btnSend} disabled={this.state.itemPressedDisabled} onPress={() => { this.attach1() }}>
                        <Image source={require('../Images/sent.png')} style={styles.iconSend} />
                      </TouchableOpacity>
                    }


                  </View>

                }



              </View>
            </View>}
          {/* </View> */}
          {/* </KeyboardAvoidingView> */}
        </Container>

        {/* </TouchableWithoutFeedback> */}
      </KeyboardAvoidingView >

    );
  }
}
//Styles fro UI
const styles = StyleSheet.create({
  container: {
    flex: 1,
    backgroundColor: '#efe6dd'
  },
  list: {
    paddingHorizontal: 17,
  },
  footer1: {
    flexDirection: 'column',
    height: 140,
    backgroundColor: '#eeeeee',
    paddingHorizontal: 10,
    padding: 5,
    paddingBottom: 15
  },
  footer: {
    flexDirection: 'row',
    height: 60,
    backgroundColor: '#efe6dd',
    paddingHorizontal: 10,
    padding: 5,
  },
  btnSend: {
    backgroundColor: "#00BFFF",
    width: 40,
    margin: 6,
    height: 40,
    borderRadius: 360,
    alignItems: 'center',
    justifyContent: 'center',
  },

  btnSendImg: {
    backgroundColor: "green",
    width: 40,
    margin: 6,
    height: 40,
    borderRadius: 360,
    alignItems: 'center',
    justifyContent: 'center',
  },

  iconSend: {
    width: 25,
    height: 25,
    alignSelf: 'center',
  },
  iconSendtop: {
    width: 25,
    height: 25,
    alignSelf: 'center',
    color: 'white',
    padding: 1
  },
  iconSendfile: {
    width: 25,
    height: 25,

  },

  inputContainer: {
    borderBottomColor: '#F5FCFF',
    backgroundColor: '#FFFFFF',
    borderRadius: 30,
    borderBottomWidth: 1,
    height: 45,
    flexDirection: 'row',
    // alignItems: 'center',
    // flex: 1,
    width: '85%',
    marginTop: 5,
    alignItems: 'baseline',

  },
  imageview: {
    width: 300,
    resizeMode: 'contain', height: 200,
  },
  msgview: {
    width: 0, height: 0
  },
  inputs: {
    height: 40,
    marginLeft: 16,
    borderBottomColor: '#FFFFFF',
    flex: 1,
    // position:'absolute',
    alignItems: 'baseline',
    paddingTop: 10,
    width: 90,
  },
  balloon: {
    maxWidth: 200,
    padding: 10,
    borderRadius: 20,

  },
  itemInSingle: {
    alignSelf: 'flex-start',
    maxWidth: '98%',
    //  flexDirection:'row'
  },
  itemOutSingle: {
    alignSelf: 'flex-end',
    //paddingLeft:10,
    maxWidth: '98%',
    // flexDirection:'row'
  },
  itemIn: {
    marginTop: -20,
    alignSelf: 'flex-start',
    maxWidth: '98%',
    //  flexDirection:'row'
  },
  itemOut: {
    marginTop: -20,
    alignSelf: 'flex-end',
    //paddingLeft:10,
    maxWidth: '98%',
    // flexDirection:'row'
  },
  itemInReply: {
    alignSelf: 'flex-start',
    maxWidth: '98%',
    //  flexDirection:'row'
  },
  itemOutReply: {
    alignSelf: 'flex-end',
    //paddingLeft:10,
    maxWidth: '98%',
    // flexDirection:'row'
  },
  time: {
    alignSelf: 'flex-end',
    // margin: 15,
    fontSize: 12,
    color: "#808080",
    paddingRight: 10
  },

  itemSingle: {
    marginVertical: 14,
    flex: 1,
    flexDirection: 'row',
    // paddingLeft:50,
    backgroundColor: "#fff",
    borderRadius: 10,
    padding: 5,
  },
  item: {
    marginVertical: 14,
    flex: 1,
    flexDirection: 'row',
    // paddingLeft:50,
    backgroundColor: "#fff",
    borderRadius: 10,
    padding: 5,
  },
  itemown: {
    marginVertical: 14,
    flex: 1,
    flexDirection: 'row',
    // paddingLeft:50,
    backgroundColor: "#fff",
    borderRadius: 10,
    padding: 5,
  },
  itemBottom: {
    marginVertical: 14,
    // flex: 1,
    width: '88%',
    flexDirection: 'row',
    // paddingLeft:50,
    backgroundColor: "#D2ECDF",
    borderRadius: 10,
    padding: 5,
  },
  itemReply: {
    marginVertical: 14,
    flex: 1,
    flexDirection: 'row',
    // paddingLeft:50,
    backgroundColor: "#e7ffdb",
    borderRadius: 10,
    padding: 5,
  },
});