import React, { PureComponent } from 'react';
import { View, Text, Dimensions, StyleSheet } from 'react-native';
import NetInfo from '@react-native-community/netinfo';
const { width } = Dimensions.get('window');
import UserDatabase from '../OfflineDB/UserDatabase';
import { API } from '../WebServices/RestClient';
import AsyncStorage from '@react-native-community/async-storage';
const db = new UserDatabase();
function MiniOfflineSign() {
  return (
    <View style={styles.offlineContainer}>
      <Text style={styles.offlineText}>No Internet Connection</Text>
    </View>
  );
}

class OfflineCheck extends PureComponent {
  constructor(props) {
    super(props);
    AsyncStorage.getItem("cropcode", (err, res) => {
      this.setState({ squadName: res });
      console.warn("squadname" + this.state.squadName);
    });
  }
  state = {
    isConnected: true
  };

  componentDidMount() {
    this.userApprovedProjects();
    // NetInfo.isConnected.addEventListener('connectionChange', this.handleConnectivityChange);
  }
  //For store Approved Projects list from offline
  addApprovedProjectsListOffline(data, cropcode) {
    db.addApprovedProjectsListOffline(data, cropcode).then((result) => {
      this.setState({
        isLoading: false,
      });
    }).catch((err) => {

      this.setState({
        isLoading: false,
      });
    })
  }
  userApprovedProjects() {
    AsyncStorage.multiGet(["cropcode", "userToken", "emp_role"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      const role = response[2][1];
      NetInfo.addEventListener(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        } else {
          fetch(API + 'getIdeas.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                crop: cropcode,
                action: 'getIdeas',
                empId: userToken,
                userType: role
              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              if (responseJson.dbconnect === 'dbconnected') {
                if (responseJson.status === 'True') {
                  this.addApprovedProjectsListOffline(responseJson.data, cropcode) //Store Approved Projects List Offline
                }
              }
              else {
                this.props.navigation.navigate('Maintenance');
              }
            })
            .catch((error) => {
              check.Maintenance();
              console.error(error);
              // log("Error", "error in listing approved projects at user side");
            });
        }
      });
    });
  }

  componentWillUnmount() {
    // NetInfo.isConnected.removeEventListener('connectionChange', this.handleConnectivityChange);
  }

  handleConnectivityChange = isConnected => {
    this.setState({ isConnected });
  };

  render() {
    if (!this.state.isConnected) {
      return <MiniOfflineSign />;
    }
    return null;
  }
}

const styles = StyleSheet.create({
  offlineContainer: {
    backgroundColor: '#b52424',
    height: 30,
    justifyContent: 'center',
    alignItems: 'center',
    flexDirection: 'row',
    width,
    position: 'absolute',
    top: 30
  },
  offlineText: { color: '#fff' }
});

export default OfflineCheck;