/*
FileName:AdminDrawerComponents.js
Version:1.0.0
Purpose:Navgate to all Admin classes from Here and logout
Devloper:Rishitha,Naveen,Harsha,Mahesh,Raju
*/
import React, { Component } from 'react';
import { NavigationActions, } from 'react-navigation';
import { DrawerActions } from '@react-navigation/native';
import { Text, View, StyleSheet, Alert, ImageBackground, Dimensions, Image, TouchableOpacity } from 'react-native'
import { Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, FooterTab } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { white } from 'ansi-colors';
import AsyncStorage from '@react-native-community/async-storage';
import Icon from 'react-native-vector-icons/FontAwesome';
import UserDatabase from "../OfflineDB/UserDatabase";
import { ScrollView } from 'react-native-gesture-handler';
const db = new UserDatabase();
import { MANAGEPROJECTS, MODULES, MAINTASKS, MANAGEROADBLOCKS, ROADBLOCKS, MANAGEEMPLOYEES, USERPREFERENCE, COMPLETEDPROJECTS, UPDATES, LOGOUT, CHANGEPASSWORD } from '../CommonComponents/Header';


export default class drawerContentComponents1 extends Component {

  constructor(props) {
    super(props);
    this.state = {
      usertype: '',
      ptime: '0',
    }
  }


  componentDidMount() {

    AsyncStorage.getItem("fullName", (err, res) => {
        this.setState({ fullName: res });


    });
    AsyncStorage.getItem("emp_role", (err, res) => {
        this.setState({ emp_role: res });

        console.warn(this.state.emp_role)
    });

}
  preferedDays = () => {
    // alert(this.state.nodays);
    const days = this.state.ptime;
    AsyncStorage.setItem('nodays', days);
    AsyncStorage.setItem("level", ''),
      this.props.navigation.navigate('AdminManageTask');

  }

  //this methos is used to ask the user about confirm about 
  logOutOption() {
    Alert.alert(
      'Alert',
      'Do you want to Logout',
      [
        {
          text: 'Cancel',
          onPress: () => console.log('Cancel Pressed'),
          style: 'cancel',
        },
        { text: 'OK', onPress: () => this.logOut() },
      ],
      { cancelable: false },
    );
  }

  //this method is used for logout the application and also clear the asyncstorage .
  logOut() {
    AsyncStorage.clear();
    db.deleteUser();
    console.warn("result");
    this.props.navigation.navigate('Auth');
  }

  navigateToScreen = (route) => (
    () => {
      const navigateAction = NavigationActions.navigate({
        routeName: route
      });
      this.props.navigation.dispatch(navigateAction);
      // this.props.navigation.dispatch(DrawerActions.closeDrawer());
    })

  render() {
    return (
      <ScrollView style={styles.container}>
         <View style={styles.headerContainer}>
                    <View style={{ alignItems: 'center', marginTop: 30, }}>
                    </View>
                    <View style={{ alignItems: 'center', marginTop: 10, }}>
                        <Image style={{ width: wp('60%'), height: hp('12%') }} source={require('../Images/agile2.png')} />

                        {/* <Image style={{ width: wp('37%'), height: hp('18%') }} source={require('../Images/drawer.png')} /> */}
                        <Text style={{ color: '#000000', paddingLeft: 10 }}>Welcome,{this.state.fullName}</Text>
                    </View>
                </View>


        <View style={styles.screenContainer}>
        <TouchableOpacity onPress={this.navigateToScreen('AdminReports1')}>
            <View style={styles.screenStyle}>
            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/reports.png')} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>Reports</Text>
            </View>
          </TouchableOpacity>
          <TouchableOpacity onPress={this.navigateToScreen('AdminProjectReports')}>
            <View style={styles.screenStyle}>
            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/reports.png')} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>ProjectReports</Text>
            </View>
          </TouchableOpacity>

          {/* <TouchableOpacity onPress={this.navigateToScreen('AdminProjectReports')}>
            <View style={styles.screenStyle}>
            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/analytics.png')} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>Admin Project Reports</Text>
            </View>
          </TouchableOpacity> */}

          <TouchableOpacity onPress={this.navigateToScreen('AdminUsageReports')}>
            <View style={styles.screenStyle}>
            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/usagereports1.png')} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>Agile Usage Reports</Text>
            </View>
          </TouchableOpacity>

          <TouchableOpacity onPress={this.navigateToScreen('AdminTimeSheet')}>
            <View style={styles.screenStyle}>
            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/timesheet.png')} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>TimeSheet</Text>
            </View>
          </TouchableOpacity>
          <TouchableOpacity onPress={this.navigateToScreen('AdminAgileSquad')}>
            <View style={styles.screenStyle}>
            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/teams.png')} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>Agile Squad</Text>
            </View>
          </TouchableOpacity>
          <TouchableOpacity onPress={this.navigateToScreen('Settings')}>
            <View style={styles.screenStyle}>
            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/adminsettings.png')} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>Settings</Text>
            </View>
          </TouchableOpacity>

            <TouchableOpacity onPress={this.navigateToScreen('AdminGroupChat')}>
                        <View style={styles.screenStyle}>
                            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/groupchat.png')} />

                            <Text style={{ color: '#000000', marginLeft: 20 }}>Chat Room</Text>
                        </View>
                    </TouchableOpacity>

          {/* <TouchableOpacity onPress={this.navigateToScreen('AdminModules')}>
            <View style={styles.screenStyle}>
              <View style={{ width: wp('8%') }}>

                <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/module.jpeg')} />
              </View>
              <Text style={{ color: '#000000', marginLeft: 20 }}>{MODULES}</Text>
            </View>
          </TouchableOpacity> */}
          {/* 
          <TouchableOpacity onPress={this.preferedDays.bind(this)}>
            <View style={styles.screenStyle}>
              <Icon size={25} name="id-badge" style={{ color: '#000000', width: wp('8%') }} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>{MAINTASKS}</Text>
            </View>
          </TouchableOpacity>
          <TouchableOpacity onPress={this.navigateToScreen('AdminRoadblock')}>
            <View style={styles.screenStyle}>
              <View style={{ width: wp('8%') }}>

                <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/userroad.jpeg')} />
              </View>
              <Text style={{ color: '#000000', marginLeft: 20 }}>{MANAGEROADBLOCKS}</Text>
            </View>
          </TouchableOpacity> */}

          {/* <TouchableOpacity onPress={this.navigateToScreen('RoadBlockList')}>
            <View style={styles.screenStyle}>
              <Icon size={25} name="bitbucket" style={{color : '#000000', width: wp('8%') }} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>RoadBlocks</Text>
            </View>
          </TouchableOpacity>     */}

          {/* <TouchableOpacity onPress={this.navigateToScreen('AdminRoadblockList')}>
            <View style={styles.screenStyle}>
              <Icon size={25} name="bitbucket" style={{ color: '#000000', width: wp('8%') }} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>{ROADBLOCKS}</Text>
            </View>
          </TouchableOpacity> */}
          {/* <TouchableOpacity onPress={this.navigateToScreen('RoadBlockList')}>
            <View style={styles.screenStyle}>
              <Icon size={25} name="bitbucket" style={{ color: '#000000', width: wp('8%') }} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>RoadBlocks</Text>
            </View>
          </TouchableOpacity> */}

          {/* <TouchableOpacity onPress={this.navigateToScreen('AdminManageEmployees')}>
            <View style={styles.screenStyle}>
              <Icon size={25} name="user" style={{ color: '#000000', width: wp('8%') }} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>{MANAGEEMPLOYEES}</Text>
            </View>
          </TouchableOpacity> */}

          {/* <TouchableOpacity onPress={this.navigateToScreen('AdminUserPreference')}>
            <View style={styles.screenStyle}>
              <Icon size={25} name="users" style={{ color: '#000000', width: wp('8%') }} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>{USERPREFERENCE}</Text>
            </View>
          </TouchableOpacity> */}

          {/* <TouchableOpacity onPress={this.navigateToScreen('AdminCompletedProjects')}>
            <View style={styles.screenStyle}>
              <Icon size={25} size={25} name="lightbulb-o" style={{ color: '#000000', width: wp('8%') }} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>{COMPLETEDPROJECTS}</Text>
            </View>
          </TouchableOpacity> */}

          {/* <TouchableOpacity onPress={this.navigateToScreen('Updates1')}>
            <View style={styles.screenStyle}>
              <Icon size={25} name="history" style={{ color: '#000000', width: wp('8%') }} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>{UPDATES}</Text>
            </View>
          </TouchableOpacity> */}


          {/* <TouchableOpacity onPress={this.navigateToScreen('AdminPassword')}>
            <View style={styles.screenStyle}>
              <Icon size={25} name='lock' style={{ color: '#000000', width: wp('8%') }} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>{CHANGEPASSWORD}</Text>
            </View>
          </TouchableOpacity> */}

          
          <TouchableOpacity onPress={this.logOutOption.bind(this)}>
            <View style={styles.screenStyle}>
            <Image style={{ width: wp('6%'), height: hp('3%') }} source={require('../Images/logout.png')} />
              <Text style={{ color: '#000000', marginLeft: 20 }}>{LOGOUT}</Text>
            </View>
          </TouchableOpacity>


        </View>
      </ScrollView>

    )
  }
}

const styles = StyleSheet.create({
  container: {

    backgroundColor: '#fff',
    height: Dimensions.get('window').height,


  },
  headerContainer: {
    // height: 150,
    height: hp('23%')
  },
  headerText: {
    color: '#fff8f8',
  },
  screenContainer: {
    paddingTop: 20,

  },
  screenStyle: {

    marginTop: 2,
    flexDirection: 'row',
    alignItems: 'center',
    borderWidth: 1,
    borderColor: 'grey',
    padding: 10,
    height: hp('8%'),
    borderLeftWidth: 0,
    borderRightWidth: 0,
    borderBottomWidth: 0,



  },
  screenTextStyle: {
    fontSize: 23,
    marginLeft: 40

  },
  imageViewContainer: {
    width: wp('25%'),
    height: hp('15%'),
    resizeMode: 'cover',

    margin: 10,
    borderRadius: 400 / 2,
  },

});