/*
FileName:CalendarEvents.js
Version:1.0.0
Purpose: Add or Modify Calendar Events
Devloper:Santosh,Mahesh Reddy
*/
// import { Calendar } from 'react-native-big-calendar'
import EventCalendar from 'react-native-events-calendar';
import React, { Component } from 'react';
import { Alert, StyleSheet, TextInput, Text, View, Image, TouchableOpacity, Dimensions, Button, TouchableWithoutFeedbackBase,Linking } from 'react-native';
import NetInfo from '@react-native-community/netinfo';
// import { Agenda } from 'react-native-calendars';
import AsyncStorage from '@react-native-community/async-storage';
import log from '../LogFile/Log';
import { API } from "../WebServices/RestClient";
import { Icon, Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import Modal from "react-native-modal";
let { width } = Dimensions.get('window');
import ActionButton from 'react-native-action-button';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import DatePicker from 'react-native-datepicker';
import SearchableDropdown from 'react-native-searchable-dropdown';
import Snackbar from 'react-native-snackbar';
import moment from 'moment';
import MultiSelect from 'react-native-multiple-select';
import { Calendar } from 'react-native-big-calendar'
import DateTimePickerModal from "react-native-modal-datetime-picker";

export default class CalendarEvents extends Component {
  constructor(props) {
    super(props);
    this.state = {
      events: [
        {
          start: '2022-01-01 01:30:00',
          end: '2022-01-01 02:50:00',
          title: 'Dr. Mariana Joseph123',
          summary: '3412 Piedmont Rd NE, GA 3032',
          color: 'green',
        },
        {
          start: '2022-01-01 00:30:00',
          end: '2022-01-01 01:30:00',
          title: 'Dr. Mariana Joseph',
          summary: '3412 Piedmont Rd NE, GA 3032',
        },


      ],
      items: {},
      dataSource: [],
      resource: [],
      dataSource1: [],
      modalVisible: false,
      isVisible: false,
      event: {},
      title: '',
      eventdescription: '',
      eventtitle: '',
      assignedto: '',
      Subject: '',
      location: '',
      id: '',
      assignedName: 'Select Squad Name',
      resource1: [],
      Members: [],
      addEventData: [],
      selectedItems: [],
      title: '',
      Description: '',
      editEventData: [],
      isVisibleStart: false,
      isVisibleEnd: false,
      startDate: '',
      endDate:''
    };
    this.eventsData();
  }
  onSelectedItemsChange = selectedItems => {
    this.setState({ selectedItems });
  };
  setModalVisible = (visible) => {
    this.setState({ modalVisible: visible });
  }
  componentDidMount() {
    AsyncStorage.getItem("userName", (err, res) => {
      this.setState({ usertype: res });
      // console.warn(this.state.usertype);
    });
    AsyncStorage.getItem("userToken", (err, res) => {
      this.setState({ empId: res });
      // console.warn(this.state.empId);
    });
    AsyncStorage.getItem("cropcode", (err, res) => {
      this.setState({ cropcode: res });
      // console.warn(this.state.cropcode);
    });
    log("Debug", "user pending mytask tasks screen is loaded at user side");
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        // console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        this.getPendingtasksList(); //For pending subtaskslist from offline
      } else {
        //to get the user pending my task list
        // this.getActive(); //server
        this.getSubtaskListPending();
        this.getEvent();
        this.getEmployees();

      }
    });

  }

  //to get the user pending my task list 
  getSubtaskListPending() {

    log("Info", "UserPendingMyTask:getSubtaskListPending() method is used to get pending my tasks at user side");
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("emp_role", (err, res) => {
          const emp_role = res;
          AsyncStorage.getItem("moduleId", (err, res) => {
            const moduleId = res;
            AsyncStorage.getItem("projectId", (err, res) => {
              const projectId = res;
              //Checking the Internet Connections
              NetInfo.addEventListener(state => {
                if (state.type == "none" || state.type == "undefined" || state.type == "unknown") {
                  // console.warn(state.type);
                  Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                  });
                } else {

                  fetch(API + 'get_user_stories.php',
                    {
                      method: 'POST',
                      headers: {
                        Accept: 'application/json',
                        'Content-Type': 'application/json',
                      },
                      body: JSON.stringify({
                        crop: cropcode,
                        action: "pending",
                        //   userType: emp_role,
                        //   empId: empId,
                        moduleId: moduleId,
                        projectId: projectId,
                      })
                    })
                    .then((response) => response.json())
                    .then((responseJson) => {
                      //alert(JSON.stringify(responseJson))
                      // console.warn(JSON.stringify(responseJson))
                      if (responseJson.connection === 'connected ') {
                        if (responseJson.status === 'True') {




                          var toDoList = [];
                          var doingList = [];
                          // console.log(response)

                          //   this.state.doingList.map((x) => {
                          //   return (
                          //     doingList.push({
                          //       '2021-09-02': [{ name: 'item 1 - any js object' }],
                          //       '2021-09-03': [{ name: 'item 2 - any js object' }],
                          //       '2021-09-04': [{ name: 'item 3 - any js object' }, { name: 'any js object' }]
                          //     })
                          //   );
                          // })




                          responseJson.data.map((pending) => {
                            return (
                              (pending.activeStatus === "0") ? toDoList.push(pending) : (pending.activeStatus === "1") ? doingList.push(pending) : null
                            );
                          })

                          // const items = [];
                          //alert(JSON.stringify(responseJson.data))
                          // this.addPendingSubtasks(doingList, cropcode) //For store pending subtaskslist from offline
                          this.setState({
                            isLoading: false,
                            dataSource: [...responseJson.data],
                            isFetching: false
                          }, function () {
                          });
                          this.arrayholder = responseJson.data;
                          this.eventsData();
                        } else {
                          log("Info", "no pending my tasks at user side");
                          this.arrayholder = [];
                          this.setState({
                            isLoading: false,
                            dataSource: [],
                          })
                          this.eventsData();
                          // Snackbar.show({
                          //   title: 'No Active Backlogs',
                          //   backgroundColor: '#3BB9FF',
                          //   duration: Snackbar.LENGTH_LONG,
                          // });
                        }
                      } else {
                        this.props.navigation.navigate('Maintenance');
                      }
                    })
                    .catch((error) => {
                      check.Maintenance();
                      this.setState({
                        isLoading: false,
                      })
                      // console.error(error.message);
                      log("Error", "Error in getting of pending my tasks at user side");
                    });
                }
              });
            });

          });
        });

      });
    });

  }

  //getting the Employees list for addind maintask
  getEvent() {
    log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
    const { ModuleId } = this.state;
    const { ideaid } = this.state;
    AsyncStorage.getItem("projectId", (err, res) => {
      const projectId = res;
      // alert(projectId)

      AsyncStorage.getItem("cropcode", (err, res) => {
        const cropcode = res;
        // alert(cropcode)
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'calendar.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  crop: cropcode,
                  action: "GetEvent",
                  projectId: projectId,
                  // data:data,
                })
              })
              .then((response) => response.json())

              .then((responseJson) => {
                //alert(JSON.stringify(responseJson))
                if (responseJson.status === 'True') {
                  // console.warn("Sprints from active sprint board" + JSON.stringify(responseJson))
                  // alert(JSON.stringify(responseJson))
                  // var sprintDetails = [];

                  // responseJson.data.map((sprints) => {
                  //     const [year, month, date] = sprints.startDate.split('-');
                  //     const [year1, month1, date1] = sprints.targetDate.split('-');
                  //     return (
                  //         sprintDetails.push({ 'key': sprints.moduleId, 'epicId': sprints.ideaId, 'label': sprints.moduleDesc })
                  //     );
                  // })
                  // this.addOfflineSprints(sprintDetails, cropcode)//Store Sprint List in Offline
                  // this.setState({
                  //     resource:responseJson.data,
                  // });
                  this.setState({
                    isLoading: false,
                    resource: [...responseJson.data],
                    isFetching: false
                  }, function () {
                  });
                  this.eventsData();
                  // this.arrayholder = responseJson.data;
                } else {
                  log("Info", "no pending my tasks at user side");
                  this.arrayholder = [];
                  this.setState({
                    isLoading: false,
                    resource: [],
                  })
                  this.eventsData();
                  Snackbar.show({
                    title: 'No Active Events found',
                    backgroundColor: '#3BB9FF',
                    duration: Snackbar.LENGTH_LONG,
                  });
                }


              })
              .catch((error) => {
                console.error(error);
                log("Error", "requested projects error");
              });
          }
        });
      });
    });
  }


  //Validatios
  isValid() {
    const { eventdescription } = this.state;
    const { title } = this.state;
    const { selectedItems } = this.state;
    let valid = false;

    if (eventdescription.length === 0) {
      Snackbar.show({
        title: 'Enter All fileds',
        backgroundColor: 'red',
        duration: Snackbar.LENGTH_LONG,
      });
    }
    else if (title.length === 0) {
      Snackbar.show({
        title: 'Enter All fileds',
        backgroundColor: 'red',
        duration: Snackbar.LENGTH_LONG,
      });
    }
    else if (selectedItems.length === 0) {
      Snackbar.show({
        title: 'Enter Start Date , End Date, Selected User fileds',
        backgroundColor: 'red',
        duration: Snackbar.LENGTH_LONG,
      });
      // this.setState({ error1: 'Enter Title' });
    }

    else {
      valid = true;
    }
    return valid;
  }

  //Validatios
  isValid1() {
    const { eventdescription } = this.state;
    const { title } = this.state;
    const { selectedItems } = this.state;
    let valid = false;

    if (eventdescription.length === 0) {
      Snackbar.show({
        title: 'Enter All fileds',
        backgroundColor: 'red',
        duration: Snackbar.LENGTH_LONG,
      });
    }
    else if (title.length === 0) {
      Snackbar.show({
        title: 'Enter All fileds',
        backgroundColor: 'red',
        duration: Snackbar.LENGTH_LONG,
      });
    }
    else if (selectedItems.length === 0) {
      Snackbar.show({
        title: 'Enter Start Date , End Date, Selected User fileds',
        backgroundColor: 'red',
        duration: Snackbar.LENGTH_LONG,
      });
    }


    else {
      valid = true;
    }
    return valid;
  }

  //Validatios
  isValid2() {
    const { eventdescription } = this.state;
    const { title } = this.state;
    const { selectedItems } = this.state;
    let valid = false;

    if (title.length === 0) {
      Snackbar.show({
        title: 'Enter All fileds',
        backgroundColor: 'red',
        duration: Snackbar.LENGTH_LONG,
      });
    }

    else {
      valid = true;
    }
    return valid;
  }

  //Add event
  addEvent() {
    // alert("strat"+this.state.startDate)
    // alert("end"+this.state.endDate)
    const addEventData = {
      EventStatus: "Active",
      Subject: this.state.title,
      StartTime: this.state.startDate,
      EndTime: this.state.endDate,
      Members: this.state.selectedItems,
      Description: this.state.eventdescription,
      IsAllDay: "1",
      Location: this.state.location,
    }
    //alert(this.state.startDate)

    // alert(JSON.stringify(addEventData));
    log("Info", " addEpic(sprintId, cropcode) is used Modify the existing module");



    //userToken and crop code getting
    AsyncStorage.multiGet(["cropcode", "userName", "fullName"], (err, response) => {
      const cropcode = response[0][1];
      const userName = response[1][1];
      const fullName = response[1][1];
      console.log("userName" + userName);
      console.log("cropcode" + cropcode);
      console.log("fullName" + fullName);

      const urlBase = API + `calendarPathSetUp?key=${cropcode}&projectId=${this.state.assignedto}&empId=`;


      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        //Checking the Network connection
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          }
          // else if(targetDate >= this.state.targetdate){
          //     alert("Target Date shouild not exceed Sprint target date");
          //   }
          else {
            if (this.isValid()) {
              this.setState({ itemPressedDisabled: true })
              fetch(API + 'calendar.php',
                {
                  method: 'POST',
                  headers: {
                    Accept: 'application/json',
                    'Content-Type': 'application/json',
                  },
                  body: JSON.stringify({
                    urlBase: urlBase,
                    addEvent: addEventData,
                    action: "Add",
                    corp_code: cropcode,
                    fullName: fullName,
                    userName: userName,
                    projectId: projectId,

                  })
                })
                .then((response) => response.json())
                .then((responseJson) => {
                  console.log(responseJson)
                  // alert(JSON.stringify(responseJson))
                  if (responseJson.status == 'True') {
                    this.setState({ open: false });
                    this.setState({
                      itemPressedDisabled: false,
                      isVisible: !this.state.isVisible,
                      // title: '',
                      // location: '',
                      // startDate: '',
                      // targetDate: '',
                      // eventdescription: '',
                    })
                    this.getEvent();
                    //Navigate to AddModule screen
                    // this.props.navigation.navigate("UserTaskStatus1");
                    // this.props.navigation.navigate("UserBacklog");
                    Snackbar.show({
                      title: 'Event Added',
                      backgroundColor: 'green',
                      duration: Snackbar.LENGTH_LONG,
                    });
                  }
                  // this.refs.toast.show('Project Modified', Toast.Duration.long, Toast.Position.center);

                })
                .catch((error) => {
                  console.error(error);
                  log("Error", "Modify the existing module error");
                });
            }

          }
        });
      });
    });

  }


  //Modify the event
  editEvent() {
    // alert(this.state.event.Id)
    // alert(this.state.title)
    // alert(this.state.start)
    const editEventData = {
      EventStatus: "Active",
      Subject: this.state.title,
      Id: this.state.Id,
      StartTime: this.state.startDate,
      EndTime: this.state.endDate,
      Members: this.state.selectedItems,
      Description: this.state.eventdescription,
      IsAllDay: "1",
      Location: this.state.location,
    }
    // alert(this.state.Menbers)
    // alert(editEventData)
    // alert(JSON.stringify(editEventData));
    console.warn("calendar data" + JSON.stringify(editEventData))

    // alert(JSON.stringify(addEventData));
    log("Info", " addEpic(sprintId, cropcode) is used Modify the existing module");



    //userToken and crop code getting
    AsyncStorage.multiGet(["cropcode", "userName", "fullName"], (err, response) => {
      const cropcode = response[0][1];
      const userName = response[1][1];
      const fullName = response[1][1];
      console.log("userName" + userName);
      console.log("cropcode" + cropcode);
      console.log("fullName" + fullName);

      const urlBase = API + `calendarPathSetUp?key=${cropcode}&projectId=${this.state.assignedto}&empId=`;

      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        //Checking the Network connection
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          }
          // else if(targetDate >= this.state.targetdate){
          //     alert("Target Date shouild not exceed Sprint target date");
          //   }
          else {
            if (this.isValid1()) {
              this.setState({ itemPressedDisabled: true })
              fetch(API + 'calendar.php',
                {
                  method: 'POST',
                  headers: {
                    Accept: 'application/json',
                    'Content-Type': 'application/json',
                  },
                  body: JSON.stringify({
                    urlBase: urlBase,
                    current: editEventData,
                    action: "update",
                    corp_code: cropcode,
                    fullName: fullName,
                    userName: userName,
                    projectId: projectId,

                  })
                })
                .then((response) => response.json())
                .then((responseJson) => {
                  console.log(responseJson)
                  //  alert(JSON.stringify(responseJson))
                  if (responseJson.status == 'True') {
                    this.getEvent();
                    this.setState({ open: false });
                    this.setState({

                      itemPressedDisabled: false,
                      status: !this.state.status,
                    })
                    this.getEvent();
                    //Navigate to AddModule screen
                    // this.props.navigation.navigate("UserTaskStatus1");
                    // this.props.navigation.navigate("UserBacklog");
                    Snackbar.show({
                      title: 'Event Updated',
                      backgroundColor: 'green',
                      duration: Snackbar.LENGTH_LONG,
                    });
                  }
                  // this.refs.toast.show('Project Modified', Toast.Duration.long, Toast.Position.center);

                })
                .catch((error) => {
                  console.error(error);
                  log("Error", "Modify the existing module error");
                });
            }

          }
        });
      });
    });

  }

  //delete the event
  deleteEvent() {
    // alert(this.state.event.Id)
    // alert(this.state.title)
    // alert(this.state.start)
    const editEventData = {
      EventStatus: "Active",
      Subject: this.state.title,
      Id: this.state.Id,
      StartTime: this.state.startDate,
      EndTime: this.state.endDate,
      Members: this.state.selectedItems,
      Description: this.state.eventdescription,
      IsAllDay: "1",
      Location: this.state.location,
    }
    // alert(this.state.Menbers)
    // alert(editEventData)
    // alert(JSON.stringify(editEventData));
    console.warn("calendar data" + JSON.stringify(editEventData))

    // alert(JSON.stringify(addEventData));
    log("Info", " addEpic(sprintId, cropcode) is used Modify the existing module");



    //userToken and crop code getting
    AsyncStorage.multiGet(["cropcode", "userName", "fullName"], (err, response) => {
      const cropcode = response[0][1];
      const userName = response[1][1];
      const fullName = response[1][1];
      console.log("userName" + userName);
      console.log("cropcode" + cropcode);
      console.log("fullName" + fullName);

      const urlBase = API + `calendarPathSetUp?key=${cropcode}&projectId=${this.state.assignedto}&empId=`;

      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        //Checking the Network connection
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          }
          // else if(targetDate >= this.state.targetdate){
          //     alert("Target Date shouild not exceed Sprint target date");
          //   }
          else {
            if (this.isValid2()) {
              this.setState({ itemPressedDisabled: true })
              fetch(API + 'calendar.php',
                {
                  method: 'POST',
                  headers: {
                    Accept: 'application/json',
                    'Content-Type': 'application/json',
                  },
                  body: JSON.stringify({
                    urlBase: urlBase,
                    current: editEventData,
                    action: "Delete",
                    corp_code: cropcode,
                    fullName: fullName,
                    userName: userName,
                    projectId: projectId,

                  })
                })
                .then((response) => response.json())
                .then((responseJson) => {
                  console.log(responseJson)
                  //  alert(JSON.stringify(responseJson))
                  if (responseJson.status == 'True') {
                    this.getEvent();
                    this.setState({ open: false });
                    this.setState({

                      itemPressedDisabled: false,
                      status: !this.state.status,
                    })
                    this.getEvent();
                    //Navigate to AddModule screen
                    // this.props.navigation.navigate("UserTaskStatus1");
                    // this.props.navigation.navigate("UserBacklog");
                    Snackbar.show({
                      title: 'Event Deleted',
                      backgroundColor: 'red',
                      duration: Snackbar.LENGTH_LONG,
                    });
                  }
                  // this.refs.toast.show('Project Modified', Toast.Duration.long, Toast.Position.center);

                })
                .catch((error) => {
                  console.error(error);
                  log("Error", "Modify the existing module error");
                });
            }

          }
        });
      });
    });

  }
  //getting the Employees list for addind maintask
  getEmployees() {
    log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
    const { ModuleId } = this.state;
    const { ideaid } = this.state;
    // console.warn("ModuleId"+ModuleId)
    AsyncStorage.getItem("projectId", (err, res) => {
      const projectId = res;

      AsyncStorage.getItem("cropcode", (err, res) => {
        const cropcode = res;
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'agile_squads.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  crop: cropcode,
                  projectId: projectId,

                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                // alert(JSON.stringify(responseJson))
                if (responseJson.status === 'True') {

                  var empList = [];
                  responseJson.data.map((employee) => {
                    return (
                      empList.push({
                        'id': employee.email, 'name': employee.name
                      })
                    );
                  })

                  this.setState({
                    resource1: empList,
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "requested projects error");
              });
          }
        });
      });
    });
  }


  //Method for Unassigned task to set
  eventsData() {
    console.warn("datasource" + JSON.stringify(this.state.dataSource))
    // alert("datasource" + JSON.stringify(this.state.dataSource))

    console.warn("unassignedTasks testing" + JSON.stringify(this.state.resource))
    const dataSource1 = this.state.dataSource.concat(this.state.resource)



    this.setState({
      dataSource1: dataSource1,
    })
    // this.onRefresh();
    // alert("Test" + JSON.stringify(dataSource1))
    console.warn("manageTasks" + JSON.stringify(dataSource1))
  }
  _eventTapped(event) {
    // alert((event.title));
    // this.setState({
    //   event: event,

    // })
    this.setState({
      title: event.title,
      start: event.start,
      end: event.end,
      location: event.location,
      summary: event.summary,
      status: event.status,
      eventdescription: event.eventdescription,
      Id: event.Id,
      Location: event.Location



    })
    this.setModalVisible(true)
  }
  toggleModal = () => {
    setModalVisible(!isModalVisible);
  };


    // Start Date Date with time
  handlePickerStart = (datetime) => {
    this.setState({
      isVisibleStart: false,
      startDate: moment(datetime).format('YYYY-MM-DDTHH:mm')
    })

  }
  showPickerStart = () => {
    this.setState({
      isVisibleStart: true
    })
  }

  hidePickerStart = () => {
    this.setState({
      isVisibleStart: false
    })

  }

    // End Date Date with time
    handlePickerEnd = (datetime) => {
      this.setState({
        isVisibleEnd: false,
        endDate: moment(datetime).format('YYYY-MM-DDTHH:mm')
      })
  
    }
    showPickerEnd = () => {
      this.setState({
        isVisibleEnd: true
      })
    }
  
    hidePickerEnd = () => {
      this.setState({
        isVisibleEnd: false
      })
  
    }

  render() {

    const events = [
      {
        title: 'Meeting',
        start: new Date(2020, 1, 11, 10, 0),
        end: new Date(2020, 1, 11, 10, 30),
      },
      {
        title: 'Coffee break',
        start: new Date(2020, 1, 11, 15, 45),
        end: new Date(2020, 1, 11, 16, 30),
      },
    ]
    //  const { selectedItems } = this.state;
    const { modalVisible, selectedItems } = this.state;

    //alert(JSON.stringify("data"+this.state.timesheet))
    // alert("data"+JSON.stringify(this.state.dataSource1))
    const timesheet = []
    this.state.dataSource1.map((x) => {
      return (
        timesheet.push({
          start: x.target_date || x.StartTime ||"2022-03-02 05:30:00+00",
          end: x.assigned_date || x.EndTime ||"2022-03-02 06:00:00+00",
          title: x.story_title || x.Subject,
          location: x.Location,
          summary: x.assignedto || x.Members,
          status: x.EventStatus,
          eventdescription: x.Description,
          Id: x.Id,
          Location: x.active_status === "0" ? "To Do"
            : x.active_status === "1" ? "In Progress"
              : x.active_status === "-1" ? "Blocked" : "Completed",

        })
      );
    })






    return (

      <Container>

        <Header
          androidStatusBarColor="#00A2C1"
          style={{
            backgroundColor: '#00A2C1',
            height: 60,
            width: Dimensions.get('window').width,
            borderBottomColor: '#ffffff',
            justifyContent: 'space-between',
          }}>
          <Left>
            <Icon name="md-menu" style={{ color: '#fff' }} onPress={() =>
              this.props.navigation.toggleDrawer()} />
          </Left>
          <Body>
            <Title style={styles.bodytitle}>Calendar Events</Title>
          </Body>

        </Header>
        <View style={{ flex: 1, }}>
          <Calendar
            events={timesheet}
            height={600}
             mode='3days'
             onPressCell={() => { this.setState({ isVisible: true }) }}
            onPressEvent={this._eventTapped.bind(this)}
          />



          {/* <EventCalendar
            eventTapped={this._eventTapped.bind(this)}
            events={timesheet}
            width={width}
            // initDate={'2017-09-07'}
            scrollToFirst
            upperCaseHeader
            uppercase
            scrollToFirst={false}
          /> */}

        </View>
        <Modal isVisible={modalVisible} style={this.state.event.status === 0 ? styles.mssize : styles.mbsize}>
          <View style={{ backgroundColor: 'white', padding: 10 }}>
            <View style={{ width: '100%', backgroundColor: '#00A2C1', padding: 2 }}>
              <Text style={{ color: 'white', fontSize: 16 }}>{this.state.title}</Text>
            </View>
            <Text style={{ padding: 5 }}>{moment(this.state.start).format('MM.DD.YYYY hh:mm:ss')}</Text>
            <Text style={{ paddingLeft: 5 }}>{this.state.summary}</Text>
            <Text style={{ paddingLeft: 5,color:'#00A2C1' }}  onPress={() => Linking.openURL(this.state.location)}>{this.state.location}</Text>
            <Text style={{ paddingLeft: 5, paddingTop: 5 }}>{this.state.Location}</Text>




            <View style={{ flexDirection: 'row', marginTop: 10, alignSelf: 'flex-end' }}>
              <TouchableOpacity onPress={this.deleteEvent.bind(this)} disabled={this.state.itemPressedDisabled}>
                <Image style={{ width: 27, height: 27, marginRight: 10 }} source={require('../Images/bin.png')} />

              </TouchableOpacity>
              <TouchableOpacity style={{ padding: 5, backgroundColor: '#00A2C1', marginLeft: 8, borderRadius: 10, width: 50, }}
                onPress={() => this.setModalVisible(!modalVisible)}
              >
                <Text style={{ color: 'white', fontSize: 12 }}>CLOSE</Text>
              </TouchableOpacity>

            </View>


            {
              this.state.status &&
              <View>
                <View
                  style={{
                    borderBottomColor: 'black',
                    borderBottomWidth: 1,
                    marginTop: 10
                  }}
                />
                <Text style={{ marginTop: 5 }}>UPDATE EVENT DETAILS</Text>

                <View style={{ marginLeft: 10, width: '100%', }}>

                  <Text style={{ color: 'red' }}>{this.state.error2}</Text>


                  <TextInput placeholder="Title" style={{ width: '90%', borderBottomWidth: 0.5, borderBottomColor: 'black' }}
                    value={this.state.title}
                    onChangeText={(text) => this.setState({ title: text })}

                  >

                  </TextInput>

                </View>






                <View style={{ paddingTop: 20, width: '100%', marginLeft: '2%' ,flexDirection:'row'}}>

                <TouchableOpacity style={{ backgroundColor: '#00A2C1', width: '46%', marginLeft: 10, height: 30, justifyContent: 'center', alignContent: 'center', alignItems: 'center' }} onPress={this.showPickerStart}>
                <Text style={{ color: 'white' }}>Start Date</Text>

              </TouchableOpacity>
              <TouchableOpacity style={{ backgroundColor: '#00A2C1', width: '46%', marginLeft: 10, height: 30, justifyContent: 'center', alignContent: 'center', alignItems: 'center' }} onPress={this.showPickerEnd}>
                <Text style={{ color: 'white' }}>End Date</Text>

              </TouchableOpacity>

              <DateTimePickerModal
                isVisible={this.state.isVisibleStart}
                mode="datetime"
                onConfirm={this.handlePickerStart}
                onCancel={this.hidePickerStart}
              />
                <DateTimePickerModal
                isVisible={this.state.isVisibleEnd}
                mode="datetime"
                onConfirm={this.handlePickerEnd}
                onCancel={this.hidePickerEnd}
              />
                  {/* <DatePicker
                    style={{ textAlign: 'left', marginLeft: 10, borderColor: '#b6b6b6', borderWidth: 1, width: '90%', height: 40, borderRadius: 10, marginTop: 5 }}
                    date={moment(this.state.start).format('YYYY-MM-DD')}
                    mode="date"
                    placeholder="Start Date"
                    format="YYYY-MM-DD"
                    minDate="2016-05-01"
                    maxDate="2022-06-01"
                    // minDate="01-01-2019"
                    // maxDate="01-06-2075"
                    confirmBtnText="Ok"
                    cancelBtnText=""
                    showIcon={false}
                    customStyles={{
                      dateInput: { borderWidth: 0, borderBottomWidth: 2 },
                      placeholderText: { fontSize: 15, color: "#9a73ef" },
                      dateText: { textAlign: 'left', fontSize: 15, }
                    }}
                    onDateChange={(text) => this.setState({ start: text })} /> */}
                </View>

                {/* <View style={{ paddingTop: 20, width: '100%', marginLeft: '2%' }}>

                  <DatePicker
                    style={{ textAlign: 'left', marginLeft: 10, borderColor: '#b6b6b6', borderWidth: 1, width: '90%', height: 40, borderRadius: 10, marginTop: 5 }}
                    date={moment(this.state.end).format('YYYY-MM-DD')}
                    mode="date"
                    placeholder="Target Date"
                    format="YYYY-MM-DD"
                    minDate="2016-05-01"
                    maxDate="2022-06-01"
                    // minDate="01-01-2019"
                    // maxDate="01-06-2075"
                    confirmBtnText="Ok"
                    cancelBtnText=""
                    showIcon={false}
                    customStyles={{
                      dateInput: { borderWidth: 0, borderBottomWidth: 2 },
                      placeholderText: { fontSize: 15, color: "#9a73ef" },
                      dateText: { textAlign: 'left', fontSize: 15, }
                    }}
                    onDateChange={(text) => this.setState({ end: text })} />
                </View> */}
                <View style={{ width: '90%', marginTop: 10 }}>
                  <MultiSelect
                    hideTags
                    items={this.state.resource1}
                    style={{ width: '90%' }}
                    uniqueKey="id"
                    ref={(component) => { this.multiSelect = component }}
                    onSelectedItemsChange={this.onSelectedItemsChange}
                    selectedItems={selectedItems}
                    selectText="Select Attendees"
                    searchInputPlaceholderText="Search Items..."
                    onChangeInput={(text) => console.log(text)}
                    // altFontFamily="ProximaNova-Light"
                    tagRemoveIconColor="#CCC"
                    tagBorderColor="#CCC"
                    tagTextColor="#CCC"
                    selectedItemTextColor="#CCC"
                    selectedItemIconColor="#CCC"
                    itemTextColor="#000"
                    displayKey="name"
                    searchInputStyle={{ color: '#CCC' }}
                    submitButtonColor="#CCC"
                    submitButtonText="Submit"
                  />
                </View>
                {/* <View style={{ paddingTop: 10, width: '100%', marginLeft: '4%' }}>

                  <SearchableDropdown
                    placeholder={this.state.assignedName}
                    onTextChange={text => console.log(text)}
                    // value={this.state.assignedName}
                    // onItemSelect={item => item.name}
                    onItemSelect={(item) => this.setState({ assignedto: item.id, assignedName: item.name })}
                    placeholderTextColor='black'
                    containerStyle={{ padding: 5, width: '94%' }}
                    textInputStyle={{
                      padding: 12,
                      borderWidth: 1,
                      borderColor: '#ccc',
                      // backgroundColor: '#FAF7F6',
                    }}
                    itemStyle={{
                      padding: 10,
                      marginTop: 2,
                      backgroundColor: '#FAF9F8',
                      borderColor: '#bbb',
                      borderWidth: 1,
                    }}
                    itemTextStyle={{

                      color: '#222',
                    }}
                    itemsContainerStyle={{

                      maxHeight: '50%',
                      width: '90%'
                    }}
                    items={this.state.resource1}

                    defaultIndex={2}

                    // placeholder=""

                    resetValue={false}

                    underlineColorAndroid="transparent"

                  />
                  <Text style={{ color: 'red' }}>{this.state.error3}</Text>
                </View> */}


                <View style={{ marginLeft: 10, width: '100%', }}>

                  <Text style={{ color: 'red' }}>{this.state.error2}</Text>
                  <TextInput placeholder="Description" style={{ width: '90%', borderBottomWidth: 0.5, borderBottomColor: 'black' }}
                    value={this.state.eventdescription}
                    onChangeText={(eventdescription) => this.setState({ eventdescription: eventdescription })}></TextInput>

                </View>

                <View style={{ flexDirection: 'row', }}>
                  <TouchableOpacity style={styles.modifyopensave} onPress={this.editEvent.bind(this)} disabled={this.state.itemPressedDisabled}>
                    <Text style={{ color: 'white' }}>UPDATE</Text>

                  </TouchableOpacity>


                </View>

              </View>

            }

          </View>
        </Modal>
        {/* <ActionButton buttonColor="rgba(231,76,60,1)" onPress={() => { this.setState({ isVisible: true }) }}>

        </ActionButton> */}
        <Modal
          style={{ flex: 1, backgroundColor: 'grey', margin: 0 }}
          animationType={"fade"}
          transparent={false}
          visible={this.state.isVisible}
          onRequestClose={() => { console.log("Modal has been closed.") }}>

          <View style={{ alignItems: "center", backgroundColor: 'white' }}>
            <Text style={{ fontSize: 18, justifyContent: 'center', alignSelf: 'center', justifyContent: 'center' }}>Add Event</Text>

            <View style={{ marginLeft: 10, width: '98%', }}>

              <Text style={{ color: 'red' }}>{this.state.error2}</Text>
              <TextInput placeholder="Title" style={{ width: '96%', borderBottomWidth: 0.5, borderBottomColor: 'black' }}
                value={this.state.title}
                onChangeText={(text) => this.setState({ title: text })}></TextInput>

            </View>
            <View style={{ width: '90%', marginTop: 10 }}>
              <MultiSelect
                hideTags
                items={this.state.resource1}
                style={{ width: '90%' }}
                uniqueKey="id"
                ref={(component) => { this.multiSelect = component }}
                onSelectedItemsChange={this.onSelectedItemsChange}
                selectedItems={selectedItems}
                selectText="Select Attendees"
                searchInputPlaceholderText="Search Items..."
                onChangeInput={(text) => console.log(text)}
                // altFontFamily="ProximaNova-Light"
                tagRemoveIconColor="#CCC"
                tagBorderColor="#CCC"
                tagTextColor="#CCC"
                selectedItemTextColor="#CCC"
                selectedItemIconColor="#CCC"
                itemTextColor="#000"
                displayKey="name"
                searchInputStyle={{ color: '#CCC' }}
                submitButtonColor="#CCC"
                submitButtonText="Submit"
              />
            </View>
            <View style={{ marginLeft: 10, width: '98%', }}>

              <Text style={{ color: 'red' }}>{this.state.error2}</Text>
              <TextInput placeholder="Subject" style={{ width: '96%', borderBottomWidth: 0.5, borderBottomColor: 'black' }}
                value={this.state.location}
                onChangeText={(text) => this.setState({ location: text })}></TextInput>

            </View>



            <View style={{ paddingTop: 20, width: '100%', marginLeft: '2%',flexDirection:'row' }}>

              <TouchableOpacity style={{ backgroundColor: '#00A2C1', width: '46%', marginLeft: 10, height: 30, justifyContent: 'center', alignContent: 'center', alignItems: 'center' }} onPress={this.showPickerStart}>
                <Text style={{ color: 'white' }}>Start Date</Text>

              </TouchableOpacity>
              <TouchableOpacity style={{ backgroundColor: '#00A2C1', width: '46%', marginLeft: 10, height: 30, justifyContent: 'center', alignContent: 'center', alignItems: 'center' }} onPress={this.showPickerEnd}>
                <Text style={{ color: 'white' }}>End Date</Text>

              </TouchableOpacity>

              <DateTimePickerModal
                isVisible={this.state.isVisibleStart}
                mode="datetime"
                onConfirm={this.handlePickerStart}
                onCancel={this.hidePickerStart}
              />
                <DateTimePickerModal
                isVisible={this.state.isVisibleEnd}
                mode="datetime"
                onConfirm={this.handlePickerEnd}
                onCancel={this.hidePickerEnd}
              />

              {/* <DatePicker
                style={{ textAlign: 'left', marginLeft: 10, borderColor: '#b6b6b6', borderWidth: 1, width: '90%', height: 40, borderRadius: 10, marginTop: 5 }}
                date={this.state.startDate}
                mode="date"
                placeholder="Start Date"
                format="YYYY-MM-DD"
                minDate="2016-05-01"
                maxDate="2022-06-01"
                // minDate="01-01-2019"
                // maxDate="01-06-2075"
                confirmBtnText="Ok"
                cancelBtnText=""
                showIcon={false}
                customStyles={{
                  dateInput: { borderWidth: 0, borderBottomWidth: 2 },
                  placeholderText: { fontSize: 15, color: "#9a73ef" },
                  dateText: { textAlign: 'left', fontSize: 15, }
                }}
                onDateChange={(text) => this.setState({ startDate: text })} /> */}
            </View>
{/* 
            <View style={{ paddingTop: 20, width: '100%', marginLeft: '2%' }}>

              <DatePicker
                style={{ textAlign: 'left', marginLeft: 10, borderColor: '#b6b6b6', borderWidth: 1, width: '90%', height: 40, borderRadius: 10, marginTop: 5 }}
                date={this.state.targetDate}
                mode="date"
                placeholder="Target Date"
                format="YYYY-MM-DD"
                minDate="2016-05-01"
                maxDate="2022-06-01"
                // minDate="01-01-2019"
                // maxDate="01-06-2075"
                confirmBtnText="Ok"
                cancelBtnText=""
                showIcon={false}
                customStyles={{
                  dateInput: { borderWidth: 0, borderBottomWidth: 2 },
                  placeholderText: { fontSize: 15, color: "#9a73ef" },
                  dateText: { textAlign: 'left', fontSize: 15, }
                }}
                onDateChange={(text) => this.setState({ targetDate: text })} />
            </View> */}
            {/* <View style={{ paddingTop: 10, width: '100%', marginLeft: '4%' }}>

              <SearchableDropdown
                placeholder={this.state.assignedName}
                onTextChange={text => console.log(text)}
                // value={this.state.assignedName}
                // onItemSelect={item => item.name}
                onItemSelect={(item) => this.setState({ assignedto: item.id, assignedName: item.name })}
                placeholderTextColor='black'
                containerStyle={{ padding: 5, width: '94%' }}
                textInputStyle={{
                  padding: 12,
                  borderWidth: 1,
                  borderColor: '#ccc',
                  // backgroundColor: '#FAF7F6',
                }}
                itemStyle={{
                  padding: 10,
                  marginTop: 2,
                  backgroundColor: '#FAF9F8',
                  borderColor: '#bbb',
                  borderWidth: 1,
                }}
                itemTextStyle={{

                  color: '#222',
                }}
                itemsContainerStyle={{

                  maxHeight: '50%',
                  width: '90%'
                }}
                items={this.state.resource1}

                defaultIndex={2}

                // placeholder=""

                resetValue={false}

                underlineColorAndroid="transparent"

              />
              <Text style={{ color: 'red' }}>{this.state.error3}</Text>
            </View> */}


            <View style={{ marginLeft: 10, width: '100%', }}>

              <Text style={{ color: 'red' }}>{this.state.error2}</Text>
              <TextInput placeholder="Description" style={{ width: '90%', borderBottomWidth: 0.5, borderBottomColor: 'black' }}
                value={this.state.eventdescription}
                onChangeText={(text) => this.setState({ eventdescription: text })}></TextInput>

            </View>

            <View style={{ flexDirection: 'row', }}>
              <TouchableOpacity style={styles.opensave} onPress={this.addEvent.bind(this)} disabled={this.state.itemPressedDisabled}>
                <Text style={{ color: 'white' }}>SAVE</Text>

              </TouchableOpacity>
              <TouchableOpacity style={styles.opencancel} onPress={() => {
                this.setState({ isVisible: !this.state.isVisible })
              }}>
                <Text style={{ color: 'white' }}>CANCEL</Text>
              </TouchableOpacity>

            </View>


          </View>
        </Modal>




      </Container>
    );
  }


}



const styles = StyleSheet.create({
  container: {
    flex: 1,
    alignItems: 'center',
    justifyContent: 'center',
  },

  item: {
    backgroundColor: 'white',
    flex: 1,
    borderRadius: 5,
    padding: 10,
    marginRight: 10,
    marginTop: 17
  },
  cal: {
    width: Dimensions.get('window').width,
  },
  emptyDate: {
    height: 15,
    flex: 1,
    paddingTop: 30
  },
  mssize: {
    height: '20%'
  },
  mbsize: {
    height: '60%'
  },
  opencancel: {
    flex: 1,
    ...Platform.select({
      ios: {
        backgroundColor: 'red', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
      android: {
        backgroundColor: 'red', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
    }),
  },
  opensave: {
    flex: 1,
    ...Platform.select({
      ios: {
        backgroundColor: 'green', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
      android: {
        backgroundColor: 'green', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
    }),
  },
  modifyopensave: {
    flex: 1,
    ...Platform.select({
      ios: {
        backgroundColor: 'green', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
      android: {
        backgroundColor: '#00A2C1', margin: 20, height: 30, alignItems:
          "center", justifyContent: 'center'
      },
    }),
  },
  bodytitle: {
    ...Platform.select({
      ios: {
        color: '#fff', fontSize: 16, marginLeft: -300
      },
      android: {
        color: '#fff', fontSize: 16, marginLeft: 10
      },
    }),
  },
});