/*
FileName:UserBacklogTemplete.js
Version:1.0.0
Purpose:Getting Templete Data
Devloper:Mahesh Reddy,Naveen Kumar (Offline)
*/
import React, { Component } from 'react';
import moment from "moment";
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import { Platform, TextInput, StyleSheet, Text, View, Dimensions, LayoutAnimation, UIManager, TouchableOpacity, FlatList, Image, Alert } from 'react-native';
import AsyncStorage from '@react-native-community/async-storage';
// import Icon from 'react-native-vector-icons/FontAwesome5';
import Icon from 'react-native-vector-icons/FontAwesome';

import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import { NavigationEvents } from 'react-navigation';
import Main from '../Maintenance/Main';
import { SUBTASK, TITLE, DESCRIPTION, TARGETTIME, TASKSTATUS, ASSIGNEDON, STATUS, ASSIGNED_BY, EXTRAHOURS } from '../CommonComponents/Header';

const check = new Main()
import {
  BallIndicator,
  BarIndicator,
  DotIndicator,
  MaterialIndicator,
  PacmanIndicator,
  PulseIndicator,
  SkypeIndicator,
  UIActivityIndicator
} from 'react-native-indicators';

import { Collapse, CollapseHeader, CollapseBody } from "accordion-collapse-react-native";
import UserDatabase from '../OfflineDB/UserDatabase';
const db = new UserDatabase();
class ListItem extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      isLoading: true,
      expanded: false,
      dataSource2: [],
    }
    this.getMessages();
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
    });
    if (Platform.OS === 'android') {
      UIManager.setLayoutAnimationEnabledExperimental(true);
    }
  }
  changeLayout = () => {
    LayoutAnimation.configureNext(LayoutAnimation.Presets.easeInEaseOut);
    this.setState({ expanded: !this.state.expanded });
  }


  getMessages() {
    // alert("hello")
    log("Info", " getMessages(role, userToken, cropcode) is used getting task related messages");
    // const groupId = this.state.subtaskId;
    // console.warn("getmessages");
    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      this.setState({ userid: userToken });
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        // console.warn("userToken"+userToken)
        // console.warn("cropcode"+cropcode)

        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          }
          else {
            fetch(API + "mainTaskChat.php",
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({

                  action: "getAllTaskMessages",
                  corp_code: cropcode,
                  projectId: projectId
                  // sendBy: userToken,


                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                console.warn("Messages For chat application" + JSON.stringify(responseJson.data));
                // alert("Send By Name" + JSON.stringify(responseJson.data))
                // console.warn("Messages from users" + JSON.stringify(responseJson))
                // console.warn("Send By Name" + JSON.stringify(responseJson.data))
                if (responseJson.status === 'True') {

                  console.warn("Setted Data")



                  this.setState({
                    dataSource2: responseJson.data,
                  });
                  console.warn("Method data" + responseJson.data.sendBy)
                }
                else {
                  console.warn("Empty  Data")
                  this.setState({
                    dataSource: '',
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "getting task related messages error");
              });

          }
        });
      });
    });
  }

  //to verify the main task 
  // to validate the user
  MaintaskVerify() {
    log("Info", "MaintaskVerify() method is used to give alert");
    const { item } = this.props;

    Alert.alert(
      'Alert..!',
      'Do you want to Verify Task',
      [
        {
          text: 'Cancel',
          onPress: () => console.log('Cancel Pressed'),
          style: 'cancel',
        },
        { text: 'OK', onPress: () => this.MaintaskVerification(item.taskid) },
      ],
      { cancelable: false },
    );

  }

  //verifying the main task 
  MaintaskVerification(maintaskid) {
    log("Info", "MaintaskVerification(maintaskid) method is used to verify maintask");
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      NetInfo.addEventListener(state => {
        if (state.type == "none" || state.type == "undefined" || state.type == "unknown") {
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
        } else {
          fetch(API + 'manageMaintasks.php',
            {
              method: 'POST',
              headers: {
                Accept: 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                crop: cropcode,
                mainTaskId: maintaskid,
                action: 'verify'

              })
            })
            .then((response) => response.json())
            .then((responseJson) => {
              if (responseJson.status == 'True') {

              } else if (responseJson.status == 'false') {

                Alert.alert("you can not verify tasks untill subtasks are verified");
                log("Warn", "you can not verify tasks untill subtasks are verified");

              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "Maintask verification error");
            });
        }
      });
    });
  }

  //Navigates to TaskChat Screen
  TaskChat(taskid, action, msgCount) {
    console.warn("msgCount" + msgCount);
    console.warn("taskid" + taskid);
    log("Info", "UserPendingMyTasks:TaskChat(item, index) used to navigate to taskchat")
    this.props.navigation.navigate("TaskChat", { id: taskid, action: "maintask", sno: msgCount });
  }


  render() {
    const { item } = this.props;
    const { empId, } = this.props;

    let buttonDelete;
    if (item.assigned_by === empId) {
      // button6 = null;
      buttonDelete =

        <TouchableOpacity  onPress={() => this.props.deleteAction()} >
            <Icon style={{marginRight:5}} name="trash-o" size={25} color="red"  />
        </TouchableOpacity>
    }
    else {
      buttonDelete = null;
    }
    let Dependency = <View style={styles.box1}>

      <View style={{ flexDirection: 'row', width: wp('50%') }}>
        <Text style={styles.signUpText000} >Dependency: {item.dependencyId}</Text>
        {/* <Text style={styles.signUpText1111} ></Text> */}

        {/* <Text style={styles.signUpText1} >{item.date}</Text> */}
      </View>
      <Text style={styles.signUpText002} >Dependent:{item.dependencyTitle}</Text>

    </View>




    return (
      <View>
        {/* <Collapse style={styles.container}>
          <CollapseHeader style={styles.boxheader}> */}
        <View style={styles.container}>
          <View style={styles.boxheader}>
            <TouchableOpacity activeOpacity={0.8} onPress={this.changeLayout} >
              <View style={{ flexDirection: 'row' }}>
                <View style={{ flexDirection: 'row', width: wp('30%') }}>
                  {/* <Text style={styles.signUpText0} >{(this.props.cropcode).substring(0, 3).toUpperCase()}:</Text> */}
                  {/* <Text style={styles.signUpText0} >Id:</Text> */}

                  {/* <Text style={styles.signUpText1} >{item.story_id.substring(0, 5).toUpperCase()}</Text> */}

                  {/* <Text style={{ paddingLeft: 10 }}>{item.assignedto}</Text> */}
                </View>


              </View>



              <View style={styles.box1}>

                <View style={{ flexDirection: 'row', width: wp('60%'), marginRight: 10 }}>
                  <Text style={styles.signUpText00} >{TITLE}:</Text>
                  <Text style={styles.signUpText11} >{item.story_title}</Text>
                </View>
                <View style={{flexDirection: 'row',marginLeft:20 }}>

                  {buttonDelete}
                  <TouchableOpacity style={{ justifyContent: 'flex-end' }} onPress={() => this.props.ReassignStory()}>
                    <Image style={{ width: 25, height: 25 }} source={require('../Images/reassign.png')} />
                  </TouchableOpacity>

                </View>

              </View>



            </TouchableOpacity>
          </View>
          {/* </CollapseHeader> */}
          <View style={{ height: this.state.expanded ? null : 0, overflow: 'hidden' }}>
            <CollapseBody>


              <View style={{ flexDirection: 'row', paddingRight: 25, width: wp('80%') }}>
                <Text style={styles.signUpText44} >{DESCRIPTION}:</Text>
                <Text style={styles.signUpText33} >{item.story_desc}</Text>
                {/* <Text style={styles.signUpText33} >{item.recipeNames}</Text> */}
              </View>

              <View style={{ flexDirection: 'row', paddingRight: 25, width: '75%' }}>
                <Text style={styles.signUpText44} >Story Points : </Text>
                <Text style={styles.signUpText33} >{item.story_points}</Text>
              </View>

              <View style={{ flexDirection: 'row', paddingRight: 25, width: '75%',paddingBottom:10 }}>

                <View style={{ flexDirection: 'row' }}>
                  <Text style={styles.signUpText000} >Priority Ievel:</Text>
                  <Text style={styles.signUpText111} >{item.priority_level}</Text>
                </View>

              </View>
            </CollapseBody>
          </View>
        </View>

      </View>
    )
  }
}
export default class UserBacklogTemplete extends Component {

  static navigationOptions = () => {
    return {
      tabBarOnPress({ navigation, defaultHandler }) {
        navigation.state.params.onTabFocus();
        defaultHandler();
        this.onRefresh();
      }
    };
  }
  constructor(props) {


    super(props);
    props.navigation.setParams({
      onTabFocus: this.handleTabFocus
    });
    this.state = {
      isLoading: true,
      dataSource: [],
      isFetching: false,
      result: '',
      open: false,
      ProjectTitle: "",
      ProjectDescription: "",
      role: '',
      userToken: '',
      empData: [],
      dependencyData: [],
      subTask: '',
      description: '',
      days: '',
      time: '',
      modifyTask: 'modify',
      dependencyid: '',
      LevelId: '',

    }
    this.arrayholder = [];
  }

  handleTabFocus = () => {
    this.onRefresh();
  };

  componentDidMount() {
    AsyncStorage.getItem("userToken", (err, res) => {
      this.setState({ empId: res });
      console.warn(this.state.empId);
    });
    AsyncStorage.getItem("cropcode", (err, res) => {
      this.setState({ cropcode: res });
      console.warn(this.state.cropcode);
    });
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        this.getCompletedSubtasksList() //Getting Completed SubtasksList offline
      } else {
        log("Debug", "user completed manage tasks screen is loaded");
        // this.userCompletedMyTasks()
        // this.getActive();
        this.userCompletedMyTasks();
      }
    });
  }


  // //Navigates to TaskChat Screen
  // TaskChat(item, index) {
  //   log("Info", "UserPendingMyTasks:TaskChat(item, index) used to navigate to taskchat")
  //   this.props.navigation.navigate("TaskChat", { taskid: item.id, action: "maintask" });
  // }
  //to refresh the data in user completed main tasks
  onRefresh() {
    this.setState({
      dataSource: [],
    })
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        this.getCompletedSubtasksList() //Getting Completed SubtasksList offline
      } else {
        log("Debug", "user completed manage tasks screen is loaded");
        // this.getActive()
        this.userCompletedMyTasks();
      }
    });
  }
  //For Completed subtaskslist from offline
  getCompletedSubtasksList() {
    AsyncStorage.getItem("cropcode", (err, res) => {
      const projectName = res;
      AsyncStorage.getItem("moduleId", (err, res) => {
        const moduleId = res;
        db.pendingSubtasksList(projectName, 'done', moduleId).then((data) => {
          console.warn("completedSubtask" + JSON.stringify(data))
          this.setState({
            dataSource: data,
            isLoading: false,
          });
          this.arrayholder = data;
        }).catch((err) => {
          console.log(err);
          this.setState = {
            isLoading: false
          }
        })
      });
    });
  }


  //For store Completed subtaskslist from offline
  addCompletedSubtasks(data, cropcode) {
    db.addPendingSubtasks(data, cropcode, 'done').then((result) => {
      this.setState({
        isLoading: false,
      });
    }).catch((err) => {
      console.log(err);
      this.setState({
        isLoading: false,
      });
    })
  }

  componentWillReceiveProps(nextProps) {
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        this.userCompletedMyTasks(); //For pending subtaskslist from offline
      } else {
        //to get the user pending my task list
        // this.getActive();
        this.userCompletedMyTasks();
      }
    });

  }
  // For store Completed subtaskslist from offline close

  componentWillReceiveProps(nextProps) {
    NetInfo.fetch().then(state => {
      if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
        console.log(state.type);
        Snackbar.show({
          title: 'No Internet Connection',
          backgroundColor: 'red',
          duration: Snackbar.LENGTH_LONG,
        });
        this.getCompletedSubtasksList();//Getting Completed SubtasksList offline
      } else {
        //to get the user pending my task list
        this.userCompletedMyTasks();
      }
    });

  }
  // componentWillReceiveProps(nextProps) {
  //   // console.log(nextProps);
  //   // console.log("re loading...........")
  //   // this.manageTasksCompleted();
  //   this.getCompletedSubtasksList();//Getting Completed SubtasksList offline
  // }

  //to get the active sprint list
  getActive() {
    log("Info", "UserCompletedMyTask:userCompletedMyTasks() method is used to get completed my tasks at user side");
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;

      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;

        AsyncStorage.getItem("emp_role", (err, res) => {
          const emp_role = res;
          //Checking the Internet Connection
          NetInfo.addEventListener(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
              console.log(state.type);
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(API + 'getUpdateSprint.php',
                {
                  method: 'POST',
                  headers: {
                    Accept: 'application/json',
                    'Content-Type': 'application/json',
                  },
                  body: JSON.stringify({
                    crop: cropcode,
                    action: "get_sprints",
                    // userType: emp_role,
                    // empId: empId,
                    // moduleId:moduleId,
                  })
                })
                .then((response) => response.json())
                .then((responseJson) => {
                  console.log(responseJson);
                  // alert(JSON.stringify(responseJson))
                  console.warn("module id setting" + JSON.stringify(responseJson))
                  if (responseJson.dbconnect === 'dbconnected') {
                    if (responseJson.status === 'True') {
                      // this.addCompletedSubtasks(responseJson.data) //For store pending subtaskslist from offline
                      // this.setState({
                      //   isLoading: false,
                      //   // dataSource: responseJson.data,
                      //   isFetching: false
                      // }, function () {
                      // });
                      this.userCompletedMyTasks(responseJson.data[0].moduleId)
                      // this.arrayholder = responseJson.data;
                    } else {
                      log("Info", "no completed my tasks at user side");
                      this.arrayholder = [];
                      this.setState({
                        isLoading: false,
                        dataSource: [],
                      })
                      Snackbar.show({
                        title: 'No Completed Task',
                        backgroundColor: '#3BB9FF',
                        duration: Snackbar.LENGTH_LONG,
                      });
                    }
                  }
                  else {
                    this.props.navigation.navigate('Maintenance');
                  }
                })
                .catch((error) => {
                  console.error(error);
                  check.Maintenance();
                  log("Error", "Error in getting of completed my tasks at user side");
                });

            }
          });

        });

      });

    });
  }

  //to get the all the user completed data list
  userCompletedMyTasks() {
    // alert(moduleId)
    log("Info", "UserCompletedMyTask:userCompletedMyTasks() method is used to get completed my tasks at user side");
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;

      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;

        AsyncStorage.getItem("emp_role", (err, res) => {
          const emp_role = res;
          AsyncStorage.getItem("moduleId", (err, res) => {
            const moduleId = res;
            AsyncStorage.getItem("projectId", (err, res) => {
              const projectId = res;
              //Checking the Internet Connection
              NetInfo.addEventListener(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                  console.log(state.type);
                  Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                  });
                } else {

                  fetch(API + 'manage_template.php',
                    {
                      method: 'POST',
                      headers: {
                        Accept: 'application/json',
                        'Content-Type': 'application/json',
                      },
                      body: JSON.stringify({
                        crop: cropcode,
                        action: "getTemplateTemp",
                        userType: emp_role,
                        sendBy: empId,
                        // moduleId: moduleId,
                        projectId: projectId,
                      })
                    })
                    .then((response) => response.json())
                    .then((responseJson) => {
                      console.log(responseJson);
                      // alert(JSON.stringify(responseJson))
                      console.warn("Done Userstories" + JSON.stringify(responseJson.data))
                      if (responseJson.status === 'True') {
                        if (responseJson.status === 'True') {
                          this.addCompletedSubtasks(responseJson.data, cropcode) //For store pending subtaskslist from offline
                          this.setState({
                            isLoading: false,
                            dataSource: responseJson.data,
                            isFetching: false
                          }, function () {
                          });
                          this.arrayholder = responseJson.data;
                        } else {
                          log("Info", "no completed my tasks at user side");
                          this.arrayholder = [];
                          this.setState({
                            isLoading: false,
                            dataSource: [],
                          })
                          Snackbar.show({
                            title: 'No Completed User Story',
                            backgroundColor: '#3BB9FF',
                            duration: Snackbar.LENGTH_LONG,
                          });
                        }
                      }
                      else {
                        // this.props.navigation.navigate('Maintenance');
                      }
                    })
                    .catch((error) => {
                      this.setState({
                        isLoading: false,
                        dataSource: [],
                      })
                      console.error(error);
                      // check.Maintenance();
                      log("Error", "Error in getting of completed my tasks at user side");
                    });

                }
              });

            });

          });
        });
      });
    });
  }



  // delete Employee start
  deleteAction(item, index) {
    // alert("moduleId" + sprintId)
    // alert("ideaId"+ideaId)
    // alert(email+""+empid)
    log("Info", "UserManageProjects1:deleteAction(moduleId) method is used to give alert");
    Alert.alert(
      'Alert..!',
      'Do you want to delete Templete',
      [
        {
          text: 'Cancel',
          onPress: () => console.log('Cancel Pressed'),
          style: 'cancel',
        },
        { text: 'OK', onPress: () => this.deleteTemplete(item, index) },
      ],
      { cancelable: false },
    );
  }

  deleteTemplete(item, index) {

    // const { us_id } = this.state;
    // alert(moduleId)
    //getting cropcode,usertoken(emp id)
    AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
      const cropcode = response[0][1];
      const userToken = response[1][1];
      console.log("userToken" + userToken);
      console.log("cropcode" + cropcode);
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        // const data = {
        //   moduleId: moduleId,
        //   action: 'delete',
        //   crop: cropcode,
        //   empId: userToken
        // };
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          }
          else {


            fetch(API + 'manage_template.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  crop: cropcode,
                  action: 'delete',
                  us_id: item.us_id,
                }


                )
              })
              .then((response) => response.json())
              .then((responseJson) => {
                // alert(JSON.stringify(responseJson));
                // this.refs.toast.show('Sprint Added', Toast.Duration.long, Toast.Position.center);
                if (responseJson.status == 'True') {
                  this.setState({ itemPressedDisabled: false })
                  //alert(responseJson.message);

                  this.userCompletedMyTasks();
                }
                else {
                  alert(responseJson.message);
                }

              })
              .catch((error) => {
                console.error(error);
                log("Error", "error in project modifying");
              });
            this.closeModal();
          }

        });
      });
    });

  }


  //Navigate to Project Modify Screen
  ReassignStory(item, index) {
    console.log(item);
    console.log(index);
    log("Info", "ReassignStory() method is used to move Add Module to Add ReassignUserStory screen");
    this.props.navigation.navigate('AssignTemplate', { action: 'add', assigntto: item.username, assignedto: item.assigned_to, projectitle: item.projectName, ideaid: item.epic_id, moduleId: item.sprint_id, taskid: item.us_id, tasktitle: item.story_title, taskdescription: item.story_desc, acceptanceCriteria: item.acceptance_criteria, storyPoints: item.story_points, priorityLevel: item.priority_level });

  }
  //Navigates to Comments Screen
  Comments(item, index) {
    log("Info", "UserInprogressMyTasks:Comments(item, index) used to navigate to Comments")
    this.props.navigation.navigate("Comments", { subtaskid: item.story_id });
  }


  _listEmptyComponent = () => {
    return (
      <View>
        <Text></Text>

      </View>
    )
  }

  //to filter the search in put by user 
  SearchFilterFunction(text) {
    log("Info", "UserApprovedProjects:SearchFilterFunction(text) method is used for search functionality");
    console.log(text);
    const newData = this.arrayholder.filter(function (item) {
      const story_title = item.story_title.toUpperCase()
      const story_title1 = text.toUpperCase()
      const assigned_by = item.assigned_by.toUpperCase()
      const assigned_by1 = text.toUpperCase()

      //   const created_on = item.created_on.toUpperCase()
      //   const created_on1 = text.toUpperCase()



      return story_title.indexOf(story_title1) > -1 ||
        assigned_by.indexOf(assigned_by1) > -1


    })
    this.setState({
      dataSource: newData,
      text: text
    })
  }

  render() {
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }
    return (
      <View style={{ height: Dimensions.get('window').height }}>
        <Item>
          <NavigationEvents
            onDidFocus={() => this.onRefresh()}
          />
          {/* <Icon name="ios-search" /> */}
          <Input placeholder="Search" onChangeText={(text) => this.SearchFilterFunction(text)} />
          <Icon style={{ marginRight: 10 }} name="search" size={20} />

        </Item>
        <View style={{ height: '66%' }}>

          <FlatList
            // data={this.props.data}
            extraData={this.state}
            keyExtractor={this._keyExtractor}
            renderItem={this._renderItem}
            style={{ flex: 1, }}
            data={this.state.dataSource}

            onRefresh={() => this.onRefresh()}
            refreshing={this.state.isFetching}

            ItemSeparatorComponent={this.FlatListItemSeparator}
            renderItem={({ item, index }) =>
              <View style={styles.container2} >
                <ListItem navigation={this.props.navigation}
                  item={item}
                  empId={this.state.empId}
                  cropcode={this.state.cropcode}
                  ReassignStory={() => this.ReassignStory(item, index)}//For Reassign User Story
                  Comments={() => this.Comments(item, index)}//For Comments
                  TaskChat={() => this.TaskChat(item, index)}//For TaskLevel Chat
                  deleteAction={() => this.deleteAction(item, index)}//delete action for Templete

                />
              </View>
            }
            keyExtractor={item => item.id}
            ListEmptyComponent={this._listEmptyComponent}
          />
        </View>
      </View>
    );
  }
}
//Styles for UI
const styles = StyleSheet.create({

  MainContainer:
  {
    flex: 1,
    width: Dimensions.get('window').width,
    height: Dimensions.get('window').height
    // width: '90%',
    // paddingLeft: hp('2%'),
  },
  container: {
    backgroundColor: '#ffffff',
    marginTop: 10,
    paddingRight: 20,
    margin: "2%",
    borderWidth: 0.8,
    borderColor: 'grey',
    width: '96%',
    borderRadius: 10,
  },
  buttonContainer: {
    width: wp('95%'),
    alignSelf: 'baseline',
    marginBottom: 10,
    color: '#d2691e',
    // backgroundColor:'#c0c0c0',
    // justifyContent:'center',
    // alignItems:'center',
    // borderWidth: 0.4,
    // borderRadius: 15,
    marginLeft: 4,
    // shadowOffset : { width: 50, height: 50 },
    // shadowColor: Platform.OS ==='ios' ? null: 'black',
    // shadowOpacity: 9,
    //elevation: 7,

  },
  signupButton: {
    //shadowOpacity: 13,
    //  backgroundColor: '#ffffff',

    // shadowColor: '#141615',

  },
  subcontainer: {
    flex: 2,
    flexDirection: 'row',
    //paddingTop: 40
  },
  signUpText0: {
    fontSize: 14,
    // paddingTop: 20,
    // fontWeight: 'bold',
    color: 'green',
    paddingLeft: 10,
    fontWeight: "bold",
  },
  signUpText1: {
    fontSize: 14,
    // paddingTop: 20,
    // fontWeight: 'bold',
    color: 'green',
    fontWeight: "bold",
    // paddingLeft: 23,
  },

  signUpText00: {
    fontSize: 14,
    // paddingTop: 20,
    // fontWeight: 'bold',
    // color: 'green',
    paddingLeft: 10,
  },
  signUpText11: {
    fontSize: 14,
    // paddingBottom: 10,
    // width: wp('60%'),
    //  paddingTop: 20,
    // fontWeight: 'bold',
    color: '#000000',
    // fontWeight: "bold",
    // paddingLeft: 23,
  },
  signUpText000: {
    fontSize: 12,
    // paddingTop: 20,
    // fontWeight: 'bold',
    // color: 'green',
    // paddingBottom: 10,
    paddingLeft: 10,
  },
  signUpText111: {
    fontSize: 12,
    // paddingBottom: 10,
    //  paddingTop: 20,
    // fontWeight: 'bold',
    color: 'black',
    // paddingLeft: 23,
  },
  end: {

    alignItems: 'flex-end',

  },
  end1: {
    flex: 1,
    // paddingTop: 20,
    justifyContent: 'space-between',

    flexDirection: 'row',
  },
  s: {
    justifyContent: 'center',

    backgroundColor: '#ed7070',
    shadowOffset: { width: 50, height: 50 },
    alignItems: 'center',
    width: wp('40%'),
    height: hp('12%'),
    borderTopLeftRadius: 10,
    borderBottomLeftRadius: 10,

  },
  signUpText2: {
    fontSize: 14,
    paddingRight: 10,
    //   paddingTop: 20,
    paddingLeft: 23,
    color: 'black',

    // fontWeight: 'bold',
    justifyContent: 'center',

  },
  signUpText02: {
    fontSize: 14,
    paddingRight: 10,
    // paddingTop: 20,
    paddingLeft: 23,
    color: 'blue',
    //paddingBottom: 5,
    // fontWeight: 'bold',
    justifyContent: 'center',

  },
  signUpText002: {
    fontSize: 12,
    paddingRight: 10,
    // paddingTop: 20,
    paddingLeft: 23,
    // color: 'red',
    // paddingBottom: 5,
    // fontWeight: 'bold',
    justifyContent: 'center',

  },
  signUpText3: {

    // paddingBottom: 5,
    // paddingLeft: 23,
    fontSize: 14,
    // paddingRight:hp('-10%'),
    paddingRight: 13,
    // fontWeight: "bold",
    // fontWeight: 'bold',
    color: 'green',
    alignItems: 'center',
  },
  signUpText4: {
    //  paddingBottom: 5,
    paddingLeft: 10,
    // fontWeight: 'bold',
    //color: 'black',
    fontSize: 14,
    color: 'green',
    alignItems: 'center',
  },


  signUpText33: {

    // paddingBottom: 5,
    // paddingLeft: 23,
    fontSize: 12,
    // paddingRight:hp('-10%'),
    paddingRight: 13,
    // fontWeight: 'bold',
    // paddingTop: -15,
    alignItems: 'center',
  },
  signUpText44: {
    //paddingBottom: 5,
    paddingLeft: 10,
    // fontWeight: 'bold',
    // paddingTop: -15,
    //color: 'black',
    fontSize: 12,
    alignItems: 'center',
  },

  signup: {
    //paddingTop:20,
    color: "#FFF",
  },
  boxone: {
    flex: 1,
    marginTop: 5,

  },
  boxtwo: {
    flex: 1,

  },
  boxthree: {
    flex: 1,

  },
  box: {
    justifyContent: 'space-between',
    flexDirection: 'row',
    position: 'relative',
    marginBottom: 5,

  },
  box1: {
    justifyContent: 'space-between',
    flexDirection: 'row',
    position: 'relative',
    marginBottom: 10,
    marginTop: 10,

  },
  signUpText: {
    fontSize: 20,
    justifyContent: 'center',


    color: 'white',
    alignSelf: 'center',
  },
  boxheader: {
    justifyContent: 'space-between',
    flexDirection: 'column',
    position: 'relative',
    marginBottom: 5,

  },
});