/*
FileName:UserProfileKudos.js
Version:1.0.0
Purpose:Getting the List of UserProfileKudos of user 
Devloper:Mahesh Reddy
*/
import React, { Component } from 'react';
import moment from "moment";
import { Left, Button, Container, Header, Content, Item, Input, Body, Right, Title } from 'native-base';
import { Platform, TextInput, StyleSheet, Text, View, Dimensions, LayoutAnimation, UIManager, TouchableOpacity, FlatList, Image, Alert } from 'react-native';
import AsyncStorage from '@react-native-community/async-storage';
import Icon from 'react-native-vector-icons/FontAwesome5';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import { NavigationEvents } from 'react-navigation';
import Main from '../Maintenance/Main';
import { SUBTASK, TITLE, DESCRIPTION, TARGETTIME, TASKSTATUS, ASSIGNEDON, STATUS, ASSIGNED_BY, EXTRAHOURS } from '../CommonComponents/Header';

const check = new Main()
import {
    BallIndicator,
    BarIndicator,
    DotIndicator,
    MaterialIndicator,
    PacmanIndicator,
    PulseIndicator,
    SkypeIndicator,
    UIActivityIndicator
} from 'react-native-indicators';

import { Collapse, CollapseHeader, CollapseBody } from "accordion-collapse-react-native";
import UserDatabase from '../OfflineDB/UserDatabase';
const db = new UserDatabase();
class ListItem extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            isLoading: true,
            expanded: false,
            dataSource2: [],
        }

        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;
        });
        if (Platform.OS === 'android') {
            UIManager.setLayoutAnimationEnabledExperimental(true);
        }
    }
    changeLayout = () => {
        LayoutAnimation.configureNext(LayoutAnimation.Presets.easeInEaseOut);
        this.setState({ expanded: !this.state.expanded });
    }


    render() {
        const { item } = this.props;
        let Dependency = <View style={styles.box1}>

            <View style={{ flexDirection: 'row', width: wp('50%') }}>
                <Text style={styles.signUpText000} >Dependency: {item.dependencyId}</Text>
                {/* <Text style={styles.signUpText1111} ></Text> */}

                {/* <Text style={styles.signUpText1} >{item.date}</Text> */}
            </View>
            <Text style={styles.signUpText002} >Dependent:{item.dependencyTitle}</Text>

        </View>



        return (
            <View>
                {/* <Collapse style={styles.container}>
          <CollapseHeader style={styles.boxheader}> */}
                <View style={styles.container}>
                    <View style={styles.boxheader}>
                        <TouchableOpacity activeOpacity={0.8} onPress={this.changeLayout} >
                            <View style={{ flexDirection: 'row' }}>
                                <View style={{ flexDirection: 'row', width: wp('30%') }}>
                                    {/* <Text style={styles.signUpText0} >{(this.props.cropcode).substring(0, 3).toUpperCase()}:</Text> */}
                                    <Text style={styles.signUpText0} >Task:</Text>

                                    <Text style={styles.signUpText1} >General Award</Text>

                                </View>

                            </View>



                            <View style={styles.box1}>

                                <View style={{ flexDirection: 'row', width: wp('70%'), marginRight: 20 }}>
                                    <Text style={styles.signUpText00} >Kudos Reason:</Text>
                                    <Text style={styles.signUpText11} >{item.kudo_description}</Text>
                                </View>

                            </View>

                            <View style={styles.box1}>

                                <View style={{ flexDirection: 'row', width: wp('60%'), marginRight: 20 }}>
                                    <Text style={styles.signUpText00} >Kudos Description:</Text>
                                    <Text style={styles.signUpText11} >{item.description}</Text>
                                </View>

                            </View>

                            <View style={styles.box1}>

                                <View style={{ flexDirection: 'row', width: wp('70%'), marginRight: 20 }}>
                                    <Text style={styles.signUpText00} >Kudos Award:</Text>
                                    <Text style={styles.signUpText11} >{item.kudos_award}</Text>
                                </View>

                            </View>


                            <View style={styles.box1}>

                                <View style={{ flexDirection: 'row', width: wp('70%'), marginRight: 20 }}>
                                    <Text style={styles.signUpText00} >Awarded By:</Text>
                                    <Text style={styles.signUpText11} >{item.awardedby}</Text>
                                </View>

                            </View>


                            <View style={styles.box1}>

                                <View style={{ flexDirection: 'row', width: wp('70%'), marginRight: 20 }}>
                                    <Text style={styles.signUpText00} >Date of Award:</Text>
                                    <Text style={styles.signUpText11} >{item.award_date}</Text>
                                </View>
                            </View>
                        </TouchableOpacity>
                    </View>
                    {/* </CollapseHeader> */}

                </View>

            </View>
        )
    }
}
export default class UserProfileKudos extends Component {

    static navigationOptions = () => {
        return {
            tabBarOnPress({ navigation, defaultHandler }) {
                navigation.state.params.onTabFocus();
                defaultHandler();
                this.onRefresh();
            }
        };
    }
    constructor(props) {


        super(props);
        props.navigation.setParams({
            onTabFocus: this.handleTabFocus
        });
        this.state = {
            isLoading: true,
            dataSource: [],
            isFetching: false,
            result: '',
            open: false,
            ProjectTitle: "",
            ProjectDescription: "",
            role: '',
            userToken: '',
            empData: [],
            dependencyData: [],
            subTask: '',
            description: '',
            days: '',
            time: '',
            modifyTask: 'modify',
            dependencyid: '',
            LevelId: '',

        }
        this.arrayholder = [];
    }

    handleTabFocus = () => {
        this.onRefresh();
    };

    componentDidMount() {
        AsyncStorage.getItem("userToken", (err, res) => {
            this.setState({ empId: res });
            console.warn(this.state.empId);
        });
        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ cropcode: res });
            console.warn(this.state.cropcode);
        });
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.getCompletedSubtasksList() //Getting Completed SubtasksList offline
            } else {
                log("Debug", "user completed manage tasks screen is loaded");
                // this.userCompletedMyTasks()
                // this.getActive();
                this.userCompletedMyTasks();
            }
        });
    }


    // //Navigates to TaskChat Screen
    // TaskChat(item, index) {
    //   log("Info", "UserPendingMyTasks:TaskChat(item, index) used to navigate to taskchat")
    //   this.props.navigation.navigate("TaskChat", { taskid: item.id, action: "maintask" });
    // }
    //to refresh the data in user completed main tasks
    onRefresh() {
        this.setState({
            dataSource: [],
        })
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.getCompletedSubtasksList() //Getting Completed SubtasksList offline
            } else {
                log("Debug", "user completed manage tasks screen is loaded");
                // this.getActive()
                this.userCompletedMyTasks();
            }
        });
    }
    //For Completed subtaskslist from offline
    getCompletedSubtasksList() {
        AsyncStorage.getItem("cropcode", (err, res) => {
            const projectName = res;
            AsyncStorage.getItem("moduleId", (err, res) => {
                const moduleId = res;
                db.pendingSubtasksList(projectName, 'done', moduleId).then((data) => {
                    console.warn("completedSubtask" + JSON.stringify(data))
                    this.setState({
                        dataSource: data,
                        isLoading: false,
                    });
                    this.arrayholder = data;
                }).catch((err) => {
                    console.log(err);
                    this.setState = {
                        isLoading: false
                    }
                })
            });
        });
    }


    //For store Completed subtaskslist from offline
    addCompletedSubtasks(data, cropcode) {
        db.addPendingSubtasks(data, cropcode, 'done').then((result) => {
            this.setState({
                isLoading: false,
            });
        }).catch((err) => {
            console.log(err);
            this.setState({
                isLoading: false,
            });
        })
    }

    componentWillReceiveProps(nextProps) {
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.userCompletedMyTasks(); //For pending subtaskslist from offline
            } else {
                //to get the user pending my task list
                // this.getActive();
                this.userCompletedMyTasks();
            }
        });

    }
    // For store Completed subtaskslist from offline close

    componentWillReceiveProps(nextProps) {
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.getCompletedSubtasksList();//Getting Completed SubtasksList offline
            } else {
                //to get the user pending my task list
                this.userCompletedMyTasks();
            }
        });

    }
    // componentWillReceiveProps(nextProps) {
    //   // console.log(nextProps);
    //   // console.log("re loading...........")
    //   // this.manageTasksCompleted();
    //   this.getCompletedSubtasksList();//Getting Completed SubtasksList offline
    // }

    //to get the active sprint list
    getActive() {
        log("Info", "UserCompletedMyTask:userCompletedMyTasks() method is used to get completed my tasks at user side");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;

            AsyncStorage.getItem("userToken", (err, res) => {
                const empId = res;

                AsyncStorage.getItem("emp_role", (err, res) => {
                    const emp_role = res;
                    //Checking the Internet Connection
                    NetInfo.addEventListener(state => {
                        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                            console.log(state.type);
                            Snackbar.show({
                                title: 'No Internet Connection',
                                backgroundColor: 'red',
                                duration: Snackbar.LENGTH_LONG,
                            });
                        } else {

                            fetch(API + 'getUpdateSprint.php',
                                {
                                    method: 'POST',
                                    headers: {
                                        Accept: 'application/json',
                                        'Content-Type': 'application/json',
                                    },
                                    body: JSON.stringify({
                                        crop: cropcode,
                                        action: "get_sprints",
                                        // userType: emp_role,
                                        // empId: empId,
                                        // moduleId:moduleId,
                                    })
                                })
                                .then((response) => response.json())
                                .then((responseJson) => {
                                    console.log(responseJson);
                                    // alert(JSON.stringify(responseJson))
                                    console.warn("module id setting" + JSON.stringify(responseJson))
                                    if (responseJson.dbconnect === 'dbconnected') {
                                        if (responseJson.status === 'True') {
                                            // this.addCompletedSubtasks(responseJson.data) //For store pending subtaskslist from offline
                                            // this.setState({
                                            //   isLoading: false,
                                            //   // dataSource: responseJson.data,
                                            //   isFetching: false
                                            // }, function () {
                                            // });
                                            this.userCompletedMyTasks(responseJson.data[0].moduleId)
                                            // this.arrayholder = responseJson.data;
                                        } else {
                                            log("Info", "no completed my tasks at user side");
                                            this.arrayholder = [];
                                            this.setState({
                                                isLoading: false,
                                                dataSource: [],
                                            })
                                            Snackbar.show({
                                                title: 'No Completed Task',
                                                backgroundColor: '#3BB9FF',
                                                duration: Snackbar.LENGTH_LONG,
                                            });
                                        }
                                    }
                                    else {
                                        this.props.navigation.navigate('Maintenance');
                                    }
                                })
                                .catch((error) => {
                                    console.error(error);
                                    check.Maintenance();
                                    log("Error", "Error in getting of completed my tasks at user side");
                                });

                        }
                    });

                });

            });

        });
    }

    //to get the all the user completed data list
    userCompletedMyTasks() {
        // alert(moduleId)
        log("Info", "UserCompletedMyTask:userCompletedMyTasks() method is used to get completed my tasks at user side");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;

            AsyncStorage.getItem("userToken", (err, res) => {
                const empId = res;

                AsyncStorage.getItem("emp_role", (err, res) => {
                    const emp_role = res;
                    AsyncStorage.getItem("moduleId", (err, res) => {
                        const moduleId = res;
                        AsyncStorage.getItem("projectId", (err, res) => {
                            const projectId = res;
                            //Checking the Internet Connection
                            NetInfo.addEventListener(state => {
                                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                                    console.log(state.type);
                                    Snackbar.show({
                                        title: 'No Internet Connection',
                                        backgroundColor: 'red',
                                        duration: Snackbar.LENGTH_LONG,
                                    });
                                } else {

                                    fetch(API + 'usersAwards.php',
                                        {
                                            method: 'POST',
                                            headers: {
                                                Accept: 'application/json',
                                                'Content-Type': 'application/json',
                                            },
                                            body: JSON.stringify({
                                                crop: cropcode,
                                                action: "getUserAwards",
                                                empId: empId,

                                            })
                                        })
                                        .then((response) => response.json())
                                        .then((responseJson) => {
                                            console.log(responseJson);
                                            // alert(JSON.stringify(responseJson))
                                            console.warn("Done Userstories" + JSON.stringify(responseJson.data))

                                            if (responseJson.status === 'True') {
                                                this.addCompletedSubtasks(responseJson.data, cropcode) //For store pending subtaskslist from offline
                                                this.setState({
                                                    isLoading: false,
                                                    dataSource: responseJson.data,
                                                    isFetching: false
                                                }, function () {
                                                });
                                                this.arrayholder = responseJson.data;
                                            } else {
                                                log("Info", "no completed my tasks at user side");
                                                this.arrayholder = [];
                                                this.setState({
                                                    isLoading: false,
                                                    dataSource: [],
                                                })
                                                Snackbar.show({
                                                    title: 'No Completed User Story',
                                                    backgroundColor: '#3BB9FF',
                                                    duration: Snackbar.LENGTH_LONG,
                                                });
                                            }


                                        })
                                        .catch((error) => {
                                            this.setState({
                                                isLoading: false,
                                                dataSource: [],
                                            })
                                            console.error(error);
                                            check.Maintenance();
                                            log("Error", "Error in getting of completed my tasks at user side");
                                        });

                                }
                            });

                        });

                    });
                });
            });
        });
    }

    //Navigate to Project Modify Screen
    ReassignStory(item, index) {
        console.log(item);
        console.log(index);
        log("Info", "ReassignStory() method is used to move Add Module to Add ReassignUserStory screen");
        this.props.navigation.navigate('ReassignUserStory', { action: 'reassign', assigntto: item.assignedto, assignedto: item.assignedTo, projectitle: item.epic_name, ideaid: item.epic_id, moduleId: item.sprint_id, taskid: item.story_id, tasktitle: item.title, taskdescription: item.subTaskDesc, acceptanceCriteria: item.acceptanceCriteria, storyPoints: item.storyPoints, priorityLevel: item.priority_level });

    }
    //Navigates to Comments Screen
    Comments(item, index) {
        log("Info", "UserInprogressMyTasks:Comments(item, index) used to navigate to Comments")
        this.props.navigation.navigate("Comments", { subtaskid: item.story_id });
    }


    _listEmptyComponent = () => {
        return (
            <View>
                <Text></Text>

            </View>
        )
    }

    //to filter the search in put by user 
    SearchFilterFunction(text) {
        log("Info", "UserApprovedProjects:SearchFilterFunction(text) method is used for search functionality");
        console.log(text);
        const newData = this.arrayholder.filter(function (item) {
            const story_id = item.story_id.toUpperCase()
            const story_id1 = text.toUpperCase()
            const assigned_date = item.assigned_date.toUpperCase()
            const assigned_date1 = text.toUpperCase()
            const target_date = item.target_date.toUpperCase()
            const target_date1 = text.toUpperCase()
            const story_desc = item.story_desc.toUpperCase()
            const story_desc1 = text.toUpperCase()
            const assignedto = item.assignedto.toUpperCase()
            const assignedto1 = text.toUpperCase()
            const title = item.title.toUpperCase()
            const title1 = text.toUpperCase()
            //   const created_on = item.created_on.toUpperCase()
            //   const created_on1 = text.toUpperCase()



            return story_id.indexOf(story_id1) > -1 ||
                assigned_date.indexOf(assigned_date1) > -1 ||
                target_date.indexOf(target_date1) > -1 ||
                story_desc.indexOf(story_desc1) > -1 ||
                title.indexOf(title1) > -1 ||
                assignedto.indexOf(assignedto1) > -1


        })
        this.setState({
            dataSource: newData,
            text: text
        })
    }

    render() {
        if (this.state.isLoading) {
            return (
                <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                    <DotIndicator color='#00A2C1' />
                </View>
            );

        }
        return (
            <View style={{ height: Dimensions.get('window').height }}>

                <Header
                    androidStatusBarColor="#00A2C1"

                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    {/* <View style ={{marginLeft:10,flexDirection:'row'}}  > */}

                    <Left>
                        <Icon size={20} name="arrow-left" style={{ color: 'white' }} onPress={() =>
                            this.props.navigation.goBack(null)} />
                    </Left>
                    <Body>
                        <Title style={{ color: '#fff', fontWeight: '600' }}>KUDOS POINTS SUMMARY</Title>
                    </Body>

                    <Right>
                        {/* <Icon name="trash-o" size={30} color="red" onPress={this.deleteAction.bind(this)} /> */}
                    </Right>

                </Header>
                <Item>
                    <NavigationEvents
                        onDidFocus={() => this.onRefresh()}
                    />
                   
                    {/* <Input placeholder="Search" onChangeText={(text) => this.SearchFilterFunction(text)} />
                    <Icon style={{ marginRight: 10 }} name="search" size={20} /> */}

                </Item>
                <View style={{ height: '88%' }}>

                    <FlatList
                        // data={this.props.data}
                        extraData={this.state}
                        keyExtractor={this._keyExtractor}
                        renderItem={this._renderItem}
                        style={{ flex: 1, }}
                        data={this.state.dataSource}

                        onRefresh={() => this.onRefresh()}
                        refreshing={this.state.isFetching}

                        ItemSeparatorComponent={this.FlatListItemSeparator}
                        renderItem={({ item, index }) =>
                            <View style={styles.container2} >
                                <ListItem navigation={this.props.navigation}
                                    item={item}
                                    empId={this.state.empId}
                                    cropcode={this.state.cropcode}
                                    ReassignStory={() => this.ReassignStory(item, index)}//For Reassign User Story
                                    Comments={() => this.Comments(item, index)}//For Comments
                                    TaskChat={() => this.TaskChat(item, index)}//For TaskLevel Chat

                                />
                            </View>
                        }
                        keyExtractor={item => item.id}
                        ListEmptyComponent={this._listEmptyComponent}
                    />
                </View>
            </View>
        );
    }
}
//Styles for UI
const styles = StyleSheet.create({

    MainContainer:
    {
        flex: 1,
        width: Dimensions.get('window').width,
        height: Dimensions.get('window').height
        // width: '90%',
        // paddingLeft: hp('2%'),
    },
    container: {
        backgroundColor: '#ffffff',
        marginTop: 10,
        paddingRight: 20,
        margin: "2%",
        borderWidth: 0.8,
        borderColor: 'grey',
        width: '96%',
        borderRadius: 10,
    },
    buttonContainer: {
        width: wp('95%'),
        alignSelf: 'baseline',
        marginBottom: 10,
        color: '#d2691e',
        marginLeft: 4,

    },

    subcontainer: {
        flex: 2,
        flexDirection: 'row',

    },
    signUpText0: {
        fontSize: 14,

        color: 'green',
        paddingLeft: 10,
        fontWeight: "bold",
    },
    signUpText1: {
        fontSize: 14,
        color: 'green',
        fontWeight: "bold",
    },

    signUpText00: {
        fontSize: 14,
        paddingLeft: 10,
    },
    signUpText11: {
        fontSize: 14,
        color: '#000000',
    },
    signUpText000: {
        fontSize: 12,
        paddingLeft: 10,
    },
    signUpText111: {
        fontSize: 12,
        color: 'black',
    },
    end: {

        alignItems: 'flex-end',

    },
    end1: {
        flex: 1,
        justifyContent: 'space-between',

        flexDirection: 'row',
    },
    s: {
        justifyContent: 'center',

        backgroundColor: '#ed7070',
        shadowOffset: { width: 50, height: 50 },
        alignItems: 'center',
        width: wp('40%'),
        height: hp('12%'),
        borderTopLeftRadius: 10,
        borderBottomLeftRadius: 10,

    },
    signUpText2: {
        fontSize: 14,
        paddingRight: 10,
        //   paddingTop: 20,
        paddingLeft: 23,
        color: 'black',

        // fontWeight: 'bold',
        justifyContent: 'center',

    },
    signUpText02: {
        fontSize: 14,
        paddingRight: 10,
        // paddingTop: 20,
        paddingLeft: 23,
        color: 'blue',
        //paddingBottom: 5,
        // fontWeight: 'bold',
        justifyContent: 'center',

    },
    signUpText002: {
        fontSize: 12,
        paddingRight: 10,
        // paddingTop: 20,
        paddingLeft: 23,
        // color: 'red',
        // paddingBottom: 5,
        // fontWeight: 'bold',
        justifyContent: 'center',

    },
    signUpText3: {

        // paddingBottom: 5,
        // paddingLeft: 23,
        fontSize: 14,
        // paddingRight:hp('-10%'),
        paddingRight: 13,
        // fontWeight: "bold",
        // fontWeight: 'bold',
        color: 'green',
        alignItems: 'center',
    },
    signUpText4: {
        //  paddingBottom: 5,
        paddingLeft: 10,
        // fontWeight: 'bold',
        //color: 'black',
        fontSize: 14,
        color: 'green',
        alignItems: 'center',
    },


    signUpText33: {

        // paddingBottom: 5,
        // paddingLeft: 23,
        fontSize: 12,
        // paddingRight:hp('-10%'),
        paddingRight: 13,
        // fontWeight: 'bold',
        // paddingTop: -15,
        alignItems: 'center',
    },
    signUpText44: {
        //paddingBottom: 5,
        paddingLeft: 10,
        // fontWeight: 'bold',
        // paddingTop: -15,
        //color: 'black',
        fontSize: 12,
        alignItems: 'center',
    },

    signup: {
        //paddingTop:20,
        color: "#FFF",
    },
    boxone: {
        flex: 1,
        marginTop: 5,

    },
    boxtwo: {
        flex: 1,

    },
    boxthree: {
        flex: 1,

    },
    box: {
        justifyContent: 'space-between',
        flexDirection: 'row',
        position: 'relative',
        marginBottom: 5,

    },
    box1: {
        justifyContent: 'space-between',
        flexDirection: 'row',
        position: 'relative',
        // marginBottom: 10,

    },
    signUpText: {
        fontSize: 20,
        justifyContent: 'center',


        color: 'white',
        alignSelf: 'center',
    },
    boxheader: {
        justifyContent: 'space-between',
        flexDirection: 'column',
        position: 'relative',
        marginBottom: 5,

    },
});